.IF DECPASS
.IFNDEF WINGID.DEFINED
Set WINGID.DEFINED = 1	! Also used by CosWin

.IFNDEF MAX.CTLHANDLE.ARRAY	! bb For storage of handles of Scrollbar and Slider controls
	SET MAX.CTLHANDLE.ARRAY		= 10
.ENDIF
Length	10.0 & LOCAL cosCtlHandle(MAX.CTLHANDLE.ARRAY,2)

Length 1.0 & Local CW.DidAutoSize
Length 1.0 & Local CW.IsChildDlg
Length 1.0 & Local CW.Remote
Length 1.0 & Local CW.ExitEvents
Length 10.0 & Local CW.Color
Length 3.0 & Local CW.Height, CW.Width, LoopCtr
Length 32 & Local CW.Font$

Set CF.MODAL.CODE	= 1				! Modal dialog support
Set CF.MODELESS.CODE	= 1			! Modeless dialog support

.IFNDEF CW.DefAppTitle$
Set CW.DefAppTitle$ = "CometWin"
.ENDIF

.IFNDEF CW.RemoteDir$
Set CW.RemoteDir$ = "$(CATOOLS)\"
.ENDIF
!========================================================================
! EventSub stuff
!========================================================================
Length 254 & Local CW.Event$, CW.Source$
Length 32 & Local CW.EventType$
Length 3.0 & Local CW.Delim

Include "CosWin.Inc"
Include "CosGdi.Inc"
Include "CopyFile.Inc"	! CometAnywhere
.ENDIF	! WINGID.DEFINED
.ELSE		! DECPASS


!
!	cosDllNames$
!	cosDllDir$
!	cosDlgId
!
!	cosDlgResult
!
CW.CreateAutoModeDialog:
	If (Asc(Sub(Sts(0), 18, 1)) < 47)
		cosFuncResult = MsgBox("This feature requires COSW client version 2.47 or later.", "Comet Error", MB.ICONSTOP)
	EndIf
	
	Gosub CW.PrepareDialog
	If (cosDllOpen NE TRUE) Then _
		Return
		
	cosDlgFlags = DLGAUTOMODE + DLGISASYNC
	Gosub COS.DialogInit
	If (cosDlgOpen EQ FALSE)
		Gosub COS.CloseDll	! Unload DLL
	EndIf
Return

CW.CreateModalDialog:
	Gosub CW.PrepareDialog
	If (cosDllOpen NE TRUE) Then _
		Return
	cosDlgFlags = DLGMODAL + DLGISASYNC
	Gosub COS.DialogInit
	If (cosDlgOpen EQ FALSE)
		Gosub COS.CloseDll	! Unload DLL
	EndIf
Return

CW.CreateModelessDialog:
	Gosub CW.PrepareDialog
	If (cosDllOpen NE TRUE) Then _
		Return
	cosDlgFlags = DLGMODELESS + DLGISASYNC
	Gosub COS.DialogInit
	If (cosDlgOpen EQ FALSE)
		Gosub COS.CloseDll	! Unload DLL
	EndIf
Return

CW.PrepareDialog:
Print (AutoMetafile=0)
	Gosub CW.Init

	If (CW.Remote EQ TRUE)
		cosCtlText$ =	Path(cosDllDir$)+cosDllNames$
		cosFileSpec$ = CW.RemoteDir$+cosDllNames$	! Use	CATOOLS for	dll location
		Gosub CW.DoCopy

		If (CopyFile.Err EQ TRUE)
			cosError$ = "Unable to load DLL"
			Gosub COS.ErrorHandler
			Return
	   EndIf

		Gosub cos.OpenDllEx
	Else
		Gosub cos.OpenDll
	EndIf

	If (cosDllOpen NE TRUE)
		cosError$ = "Unable to load DLL"
		Gosub COS.ErrorHandler
		Return
   EndIf

	cosDlgOpen = TRUE
	Gosub COS.GetAppWin		! -> cosCWnd$ - Session window for parent
	cosDlgUserID = 0
Return

CW.DoCopy:
!	Print "DoCopy source: ";cosCtlText$
!	Print "DoCopy dest: ";cosFileSpec$
	CopyFile.Flags = CPYF.DESTREMOTE + CPYF.CREATEALIAS + _
					CPYF.OVERWRITE + CPYF.MAKEDIR + CPYF.REMOTEREQ + CPYF.MODIFY
					
	Print (CopyFile = cosCtlText$, cosFileSpec$, CopyFile.Flags)
	Gosub CopyFile.GetResult
	If (CopyFile.Err EQ TRUE)
		Gosub CopyFile.GetErrorString
		cosError$ = CopyFile.ErrorString$
		Gosub COS.ErrorHandler
	EndIf
Return


CW.Close:
 	Gosub COS.DestroyAllControls

	If (CW.Font$ NE "")
		Gosub GDI.InitLogFont
		lfHeight$ = IntelD(0)
		Gosub GDI.SetViewFont
	EndIf

	Print (WallPaperRemove)
	Print (AllowMaximize = TRUE)
	Print (Show Cursor)
	EventSub

Return

CW.Init:
   If (Num(Sub(Version$, 5, 3), cosErr) LT 323)
		cosCtlText$ = "This program requires Comet Build 323 or later."
		cosSysData$ = "CometWin API"
		cosState = MB.ICONSTOP
		Gosub COS.DlgMessageBox
		Stop
   EndIf

	If (Asc(Sub(Sts(0), 18, 1)) < 33)
		cosCtlText$ = "This program requires the COSW client version 2.33 or later."
		cosSysData$ = "CometWin API"
		cosState = MB.ICONSTOP
		Gosub COS.DlgMessageBox
		Stop
   EndIf

	CW.Remote = Asc(Sub(Dstat(Term$), 21, 1))		! Save remote flag

	! Initialize CosWin
	Gosub Cos.Init

	! Initialize array used to store handles for scrollbar and slilder controls
	! Note this label is called from COS.DestroyAllControls as well
CW.DelAllCtlHandle:									! bb
	For LoopCtr = 1 to MAX.CTLHANDLE.ARRAY
		cosCtlHandle(LoopCtr,1) = -1				! Initialize cosCtlIds to -1 to indicate free entries
		cosCtlHandle(LoopCtr,2) = 0
	Next LoopCtr

Return

CW.Open:

	Gosub CW.Init

	If (CW.Font$ NE "")
		Gosub GDI.InitLogFont
		lfHeight$ = IntelD(100)		! 100% of current view font size
		lfFaceName$ = CW.Font$
		Gosub GDI.SetViewFont		! This is the comet font upon which all Centiunits are based
	EndIf

	! Establish our screen size
	If (CW.Height NE 0 And CW.Width NE 0) Then _
		Print (Screen = CW.Width, CW.Height)

	cosFuncResult = CW.Color
	cosBlue = cosFuncResult / 65536
	cosFuncResult = cosFuncResult-cosBlue*65536
	cosGreen = cosFuncResult / 256
	cosFuncResult = cosFuncResult-cosGreen*256
	cosRed = cosFuncResult

	Print (WallPaperColor = cosRed, cosGreen, cosBlue)	! Establish wallpaper
	Print (MapMode = 5)	! MM.CENTIUNITS					! Unit of measure is 100th font h/w
	Print (AllowMaximize = FALSE)								! Don't allow maximize

	Print (En);(Cs);(Hide Cursor)

	cosState = cosEW.ENABLE
	cosCwnd$ = cosDlghDlg$
	Gosub COS.AsyncNotIfyEnable

	Gosub CW.InitRedrawNotify
Return


CW.InitRedrawNotify:
	Gosub COS.GetFrameWnd
	cosCtlText$ = cosCWnd$+Intel(WM.SIZE)
	cosCWnd$ = cosDlghDlg$
	Gosub COS.AppendMsgFilter
Return

!===========================================================
! Async event handler
!===========================================================
CW.ParseEvent:
!Print "CW.ParseEvent: CW.Event$ = ";CW.Event$
	CW.ExitEvents = FALSE

	CW.EventType$ = ""
	If (Sub(CW.Event$, 1,1 ) EQ ":")
		CW.Delim = Pos('\', CW.Event$)
		If (CW.Delim NE 0) Then _
			CW.EventType$ = Sub(CW.Event$, 1, CW.Delim-1)
	EndIf

	Select Case CW.EventType$
		Case ":COMMAND"
			cosMessage = WM.COMMAND
			Gosub CW.GetCommandParams

		Case ":MESSAGE"
			Gosub CW.GetMessageParams

		Case ":NOTIFY"
			cosMessage = WM.NOTIFY
			Gosub CW.GetNotifyParams

		Case ""
			CW.EventType$ = ":HYPERLINK"
	EndSelect

!Print "CW.ParseEvent: CW.EventType$ = ";CW.EventType$
Return

CW.GetCommandParams:
	Gosub CW.GetCmdParams
!Print "Async Command = ";cosCtlId;", ";cosCommand
Return

CW.GetCmdParams:
!Print "CW.GetCmdParams: CW.Source$ = ";CW.Source$
!Print "CW.GetCmdParams: CW.Event$ = ";CW.Event$

	! Get source window name and Control ID
	cosSysData$ = CW.Source$
	gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosCWnd$ = cosDWord$
	gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosCtlId = cosDWord


	! Skip Event type
	cosSysData$ = CW.Event$
	cosInt = 1
	Gosub CW.StripParams
	If (cosErr = 1) Then _
		Return

	gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosCommand = cosDWord

	gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosCtlCWnd$ = cosDWord$
	cosErr = 0

!Print "CW.GetCmdParams cosCtlID = ";cosCtlID
!Print "CW.GetCmdParams cosCommand = ";cosCommand
Return

!=========================================================
! CW.Num32:  Converts the 10 digit decimal value contained
!				 in cosDWord$ to a 10.0 value.
!
! Returns:
!
! cosErr (1.0) will be 0 if the conversion is successful
! or 1 if an error occurred.
!
! If successful the numeric result is returned in cosDWord
! and the packed 32 bit result is returned in cosDWord$
!
!=========================================================
CW.Num32:
	cosInt = Len(cosMisc10$)

	! Use system func if it will fit
	If (cosInt LE 8)
		cosDWord = Num(cosMisc10$, cosErr)
		If (cosErr EQ 0) Then _
			cosDWord$ = IntelD(cosDWord)
		Return
	EndIf

	! Convert 1 byte at a time
	cosDWord = 0
	For cosWord = 1 to cosInt
		cosWord$ = Sub(cosMisc10$, cosWord, 1)
		If (cosWord$ LT "0" Or cosWord$ GT "9")
			cosErr = 1
			Return
		EndIf

		cosDWord = cosDWord*10 + Asc(cosWord$)-48
	Next cosWord
	cosDWord$ = IntelD(cosDWord)
	cosErr = 0
Return

! On Exit: cosCtlId contains ID of control
!           cosCommand contains notification code
!           cosCtlCWnd$ contains the control's CWnd
!           cosCWnd$ contains the dialog's CWnd
CW.GetNotifyParams:
	Gosub CW.GetCmdParams
!Print "Async Notify = ";cosCtlId;", ";cosCommand
Return

CW.StripParams:
	cosErr = 1
	For cosWord = 1 To cosInt
		CW.Delim = Pos('\', cosSysData$)
		If (CW.Delim EQ 0) Then _
			Return
		cosSysData$ = Sub(cosSysData$, CW.Delim+1, 254)
	Next cosWord
	cosSysData$ = StripL(cosSysData$)
	cosErr = 0
Return

CW.UnpackParamDW:
	CW.Delim = Pos('\', cosSysData$)
	If (CW.Delim EQ 0)
		cosMisc10$ = cosSysData$
		cosSysData$ = ""
	Else
		cosMisc10$ = Sub(cosSysData$, 1, CW.Delim-1)
		cosSysData$ = Sub(cosSysData$, CW.Delim+1, 254)
	EndIf
	Gosub CW.Num32
Return

CW.UnpackFieldDW:
	CW.Delim = Pos(',', cosSysData$)
	If (CW.Delim EQ 0)
		cosMisc10$ = cosSysData$
		cosSysData$ = ""
	Else
		cosMisc10$ = Sub(cosSysData$, 1, CW.Delim-1)
		cosSysData$ = Sub(cosSysData$, CW.Delim+1, 254)
	EndIf
	Gosub CW.Num32
Return


CW.StripFields:
	cosErr = 1
	For cosWord = 1 To cosInt
		CW.Delim = Pos(',', cosSysData$)
		If (CW.Delim EQ 0) Then _
			Return
		cosSysData$ = Sub(cosSysData$, CW.Delim+1, 254)
	Next cosWord
	cosSysData$ = StripL(cosSysData$)
	cosErr = 0
Return

.IF CF.TREEVIEW.CODE
!NMTREEVIEW$ = _	! NMHDR is excluded from this
!	"03"+ _							! Action
!	"03hh0303ss0303030303"+ _	! TVITEM Structure (Old)
!	"03hh0303ss0303030303"		! TVITEM Structure (New)

CW.TreeView.UnpackNewItem:
	! Temp copy
	cosSysData$ = CW.Event$

	! Skip first 3 fields - EventType, EventName & SourceWnd
	cosInt = 3
	Gosub CW.StripParams
	If (cosErr = 1) Then _
		Return

	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosState = cosDWord	! Action

	cosInt = 10	! skip to new TVITEM
	Gosub CW.StripFields

	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	TVItemStruc.Mask$ = IntelD(cosDWord)
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	TVItemStruc.hItem$ = IntelD(cosDWord)
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	TVItemStruc.State$ = IntelD(cosDWord)
	cosInt = 6	! skip to lParam32$
	Gosub CW.StripFields
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	TVItemStruc.lParam32$ = IntelD(cosDWord)
Return
.ENDIF	CF.TREEVIEW.CODE

.IF CF.LISTVIEW.CODE
CW.ListView.Unpack:
	gosub CW.ListView.UnpackMin
	cosInt = 2								! Skip next 2 params
	Gosub CW.StripFields
	If (cosErr = 1) Then _
		Return
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosCol = cosDWord
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosRow = cosDWord
	cosErr = 0
Return

CW.ListView.UnpackMin:
	! Temp copy
	cosSysData$ = CW.Event$

	! Skip first 3 fields - EventType, EventName & SourceWnd
	cosInt = 3
	Gosub CW.StripParams
	If (cosErr = 1) Then _
		Return

!Print "CW.ListView.UnpackMin: cosSysData$ = ";cosSysData$

	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosItemID = cosDWord
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosSubItem = cosDWord
	Gosub CW.UnpackFieldDW
	If (cosErr = 1) Then _
		Return
	cosItemState = cosDWord
	
	cosErr = 0
!Print "CW.ListView.UnpackMin = ";cosItemId;", ";cosSubItem
Return
.ENDIF

CW.GetMessageParams:
	! Get source window name
	cosSysData$ = CW.Source$
	gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosCWnd$ = cosDWord$

	! Skip EventType
	cosSysData$ = CW.Event$
	cosInt = 1
	Gosub CW.StripParams
	If (cosErr = 1) Then _
		Return

	Gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	cosMessage = cosDWord
	Gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	coswParam = cosDWord
	Gosub CW.UnpackParamDW
	If (cosErr = 1) Then _
		Return
	coslParam = cosDWord

	cosErr = 0

	If (cosMessage EQ WM.INITDIALOG)
		Print (AutoMetafile=1)
		cosDlghDlg$ = cosCWnd$
		
		cosIndex = GWL.STYLE
		Gosub COS.GetWindowLong
		cosValue = cosValue And WS.CHILD
		If (cosValue EQ WS.CHILD)
			CW.IsChildDlg = TRUE
		Else
			CW.IsChildDlg = FALSE
		EndIf

		! Initialize CosWin filters
		cosCtlText$ = ""
		Gosub COS.InitCmdFilter
		Gosub COS.InitMsgFilter
		Gosub COS.InitNotifyFilter
		Gosub COS.InitNotifyFilter2
	EndIf

	If (cosMessage EQ WM.DESTROY)
		Gosub COS.CloseDll	! Unload DLL
	EndIf

	cosCtlId = -1																! bb
	If (cosMessage EQ WM.HSCROLL OR cosMessage EQ WM.VSCROLL)	! bb
		For LoopCtr = 1 to MAX.CTLHANDLE.ARRAY
			If (cosCtlHandle(LoopCtr,2)) = coslParam		! Find entry for this handle
				cosCtlId = cosCtlHandle(LoopCtr,1)
				cosCWnd$ = inteld(coslParam)
				break
			EndIf
		Next LoopCtr
	EndIf

!Print "Async Message = ";cosMessage;", ";coswParam;", ";coslParam
Return


! Same as COS.AppendMsgFilter except that this will also make an entry in the
! array associating a control id with it's window handle for controls expecting
! scroll message.

CW.AppendMsgFilter:									! bb
	cosSysData$ = cosCtlText$
	cosCtlText$ = ""
	do until cosSysData$ = ""
		cosCtlText$ = cosCtlText$ + sub(cosSysData$,1,6)
.IFDEF WINGID.DEFINED
		cosCtlId = ihexdec(sub(cosSysData$,7,2))
		cosMessage$ = sub(cosSysData$,5,2)
		if cosMessage$ = intel(WM.HSCROLL) or _
			cosMessage$ = intel(WM.VSCROLL)
				gosub COS.GetDlgItem					! get cosCWnd$
				gosub CW.LogCtlHandle
				cosCWnd$ = sub(cosSysData$,1,4)
		endif
.ENDIF
		cosSysData$ = sub(cosSysData$,9,254)
	loop
	go COS.AppendMsgFilter


! Make an entry in the control array to associate the window handle with the control id
CW.LogCtlHandle:										! bb
	For LoopCtr = 1 to MAX.CTLHANDLE.ARRAY
		If (cosCtlHandle(LoopCtr,1)) = -1		! Find a free entry
			cosCtlHandle(LoopCtr,1) = cosCtlId
			cosCtlHandle(LoopCtr,2) = ihexdec(cosCWnd$)
			return
		EndIf
	Next LoopCtr
	cosCtlText$ = "Too many Scrollbar / Slider controls@0a@" + _
						"SET MAX.CTLHANDLE.ARRAY to the required quantity."
	cosSysData$ = CW.DefAppTitle$
	cosState = MB.ICONSTOP
	gosub COS.DlgMessageBox
Return

! Clear the array entry for cosCtlId.  This is called if the control is destroyed.
CW.DelCtlHandle:
	For LoopCtr = 1 to MAX.CTLHANDLE.ARRAY
		If (cosCtlHandle(LoopCtr,1)) = cosCtlId		! Find entry for this control id
			cosCtlHandle(LoopCtr,1) = -1
			cosCtlHandle(LoopCtr,2) = 0
			break
		EndIf
	Next LoopCtr
Return

CW.IsWindowInitializing:		! bb
	if CW.EventType$ = ":MESSAGE" and cosMessage = WM.INITDIALOG
		cosState = TRUE
	else
		cosState = FALSE
	endif
Return

CW.IsWindowClosing:				! bb
	if CW.EventType$ = ":MESSAGE" and cosMessage = WM.DESTROY
		cosState = TRUE
	else
		cosState = FALSE
	endif
Return

CW.CloseAutoModeDialog:
	If (CW.IsChildDlg EQ TRUE)
		cosDlgResult = cosCtlID
		Gosub COS.DestroyDialog
	Else
		Gosub COS.EndDialog		! cosCtlId$ -> end modal dialog
	EndIf
Return

CW.CheckAutoModeClosing:
	Gosub CW.IsWindowClosing
	If (cosState EQ TRUE)
		If (CW.IsChildDlg EQ TRUE)
			Gosub COS.GetViewWnd
			Gosub COS.SetFocus
			If (CW.DidAutoSize EQ TRUE)
				Print (ShowCursor)	! We hid the cursor during InitDialog
			EndIf
		Else
			cosDlgResult = coswParam	! Pass closing ctlID to main code
		EndIf
		CW.ExitEvents = TRUE
	EndIf
Return

CW.AutoSizeDialog:
	! Set the QCRT screen color to the same color as our dialog
	! which in this case is the system default (COLOR.BTNFACE)
	If (CW.IsChildDlg EQ TRUE And cosState NE TRUE)
		cosIndex = COLOR.BTNFACE
		Gosub COS.GetSysColor
	EndIf

CW.AutoSizeDialogEx:
	CW.DidAutoSize = TRUE
	
	! If the dialog is a child then we can put it into the view
	If (CW.IsChildDlg EQ TRUE)
		Print (HideCursor)			! Hide the cursor
		
		If (cosState EQ TRUE)
			Gosub COS.SizeViewToDialog	! Size the COSW window to match the dialog
		Else
			Print (WallPaperColor = cosRed, cosGreen, cosBlue)

			! Position the dialog centered within the inner "View" area of the window
			Gosub COS.GetViewWnd		! Get handle to window we're centering on
			cosState = 0				! Center dialog in window
			Gosub COS.SetWindowPos		! Move the window
		EndIf

	Else
		! Position the dialog centered within the outer "Frame" area of the window
		Gosub COS.GetFrameWnd		! Get handle to window we're centering on
		cosState = 0				! Center dialog in window
		Gosub COS.SetWindowPos		! Move the window
	EndIf
Return

! Returns TRUE if it's okay to validate.
! cosValue contains the ID of the control that has the focus so
! that the application can further determine need (exclude CANCEL, etc)
CW.OkToValidate:
	Gosub COS.DialogHasFocus
	If (cosState EQ TRUE)  ! Still our dialog?
		Gosub COS.GetFocus			! ->cosCWnd$
		cosIndex = GWL.ID			! Get control ID
		Gosub COS.GetWindowLong
	EndIf		! (cosState EQ TRUE)
Return

Include "CosWin.Ibs"
Include "CosGdi.Ibs"
Include "CopyFile.Inc"	! CometAnywhere
.ENDIF	! EXEPASS
