Include "CosUtl.Inc"
Include "PrintCtl.Inc"
!===============================================================================
!
! This constant determines which bitmap loader is used to send bitmaps
! to the printer driver.
!
! The LOCAL version is faster because the file is loaded by the printer
! driver using Windows calls.  The disadvantage of this method is in the
! case where the printer driver does not have access to the file as in the
! case of a remote slave printer.
!
! The UNIVERSAL version sends the bitmap to the printer driver in multiple
! blocks requiring no knowledge of the file at the server site. This version
! is slower and the code required is larger, but is probably a better choice
! for most applications.
!
!===============================================================================
SET USE.LOCAL.BITMAP = 1	! Set to 1 to use the LOCAL version

.IF USE.LOCAL.BITMAP
.ELSE
Include "DosFile.Inc"
.ENDIF

LENGTH MAX.STRING.LEN & LOCAL PtrData$	! For passing data to server
LENGTH MAX.STRING.LEN & LOCAL PtrFuncCode$	! Function to perform
LENGTH DWORD.S.LEN & LOCAL PtrFuncResult$	! Function result
LENGTH WORD.N.LEN & LOCAL PtrLoResult, PtrHiResult
LENGTH LONG.N.LEN & LOCAL PtrResult

LENGTH 2.0 & LOCAL PtrItem
LENGTH WORD.N.LEN & LOCAL PtrStyle
LENGTH WORD.N.LEN & LOCAL PtrWidth, PtrHeight
LENGTH WORD.N.LEN & LOCAL PtrScaleX, PtrScaleY
LENGTH BYTE.N.LEN & LOCAL PtrRColor, PtrGColor, PtrBColor
LENGTH WORD.N.LEN & LOCAL PtrMode
LENGTH WORD.N.LEN & LOCAL PtrX1, PtrY1
LENGTH WORD.N.LEN & LOCAL PtrX2, PtrY2
LENGTH WORD.N.LEN & LOCAL PtrX3, PtrY3
LENGTH DWORD.N.LEN & LOCAL PtrFlags
LENGTH WORD.N.LEN & LOCAL PtrIndex	! Miscellaneous

LENGTH 2 & LOCAL PtrMiscWord$
LENGTH 2 & LOCAL PtrAX$, PtrBX$, PtrCX$, PtrDX$
LENGTH 2 & LOCAL PtrDosHandle$
LENGTH DWORD.N.LEN & LOCAL PtrBytesPending
LENGTH WORD.N.LEN & LOCAL PtrBytesToDo

PtrSetPrinter:	Format PtrData$
SET PtrSetPrinterSize = MAX.STRING.LEN

! For sending up to 1000 bytes (24 byte for control)
SET MAX.BIG.BUFF = 1000
LENGTH 250 & LOCAL PtrText$(4)
PtrBigBuff: Format PtrText$(1);PtrText$(2);PtrText$(3);PtrText$(4)

.IFNDEF DRAW.TEXT.DEFINED
SET DRAW.TEXT.DEFINED = 1
!
! These constants are duplicated in #windows
! DrawText() Format Flags
SET	DT.TOP			= 0
SET	DT.LEFT			= 0
SET	DT.CENTER		= 1
SET	DT.RIGHT		= 2
SET	DT.VCENTER		= 4
SET	DT.BOTTOM		= 8
SET	DT.WORDBREAK		= 16
SET	DT.SINGLELINE		= 32
SET	DT.EXPANDTABS		= 64
SET	DT.TABSTOP		= 128
SET	DT.NOCLIP		= 256
SET	DT.EXTERNALLEADING	= 512
SET	DT.CALCRECT		= 1024
SET	DT.NOPREFIX		= 2048
SET	DT.INTERNAL		= 4096
SET	DT.EDITCONTROL		= 8192
SET	DT.PATH.ELLIPSIS	= 16384
SET	DT.END.ELLIPSIS		= 32768
SET	DT.MODIFYSTRING		= 65536
SET	DT.RTLREADING		= 131072
SET	DT.WORD.ELLIPSIS	= 262144
.ENDIF

Include "LogFont.Inc"

PtrSelectLogFont: Format (TR);(SelectFont); _
 lfHeight$; _
 lfWidth$; _
 lfEscapement$; _
 lfOrientation$; _
 lfWeight$; _
 lfItalic$; _
 lfUnderline$; _
 lfStrikeOut$; _
 lfCharSet$; _
 lfOutPrecision$; _
 lfClipPrecision$; _
 lfQuality$; _
 lfPitchAndFamily$; _
 lfFaceName$
