.IF DECPASS
.IFNDEF TD.MAXPAGES
Set TD.MAXPAGES = 10
.ENDIF
Length 10.0 & Local TD.hwndFirstFocus(TD.MAXPAGES)
Length HANDLE.S.LEN & Local TD.hwndPages$(TD.MAXPAGES)

Length 2.0 & Local TD.PageCount
Length 5.0 & Local TD.CurTab
Length 5.0 & Local TD.PageNum
Length 5.0 & Local TD.LastPageAdded
Length HANDLE.S.LEN & Local TD.hdlgMain$		! Saves the main dialog handle
Length HANDLE.S.LEN & Local TD.hWndTabCtrl$	! Saves the tab control handle
Length 10.0 & Local TD.TabCtrlId
Length 5.0 & Local TD.TabCol, TD.TabRow, TD.TabWidth, TD.TabHeight
Length 1.0 & Local TD.MainIsChild
.ELSE

! Call at start of WM.INITDIALOG processing
TD.InitTab:
	TD.PageCount = 0
	TD.CurTab = 0
	TD.MainIsChild = CW.IsChildDlg ! Save for later
	TD.hdlgMain$ = cosDlghDlg$	! Remember main dlg
	TD.TabCtrlId = cosCtlId

	! Set notify filter
	cosCWnd$ = cosDlghDlg$
	cosCtlText$ = IntelD(TD.TabCtrlId)+IntelD(TCN.SELCHANGE)+Intel(cosNMHDR.LENGTH)
	Gosub COS.AppendNotifyFilter2
	
	! Tell tab control to send notify (TCN.SETFOCUS)
	cosCtlId = TD.TabCtrlId
	Gosub COS.TabCtrl.Attach

	! TabCtrl identifier
	cosCtlId = TD.TabCtrlId
	Gosub COS.GetDlgItem
	TD.hWndTabCtrl$ = cosCWnd$	! Save tab ctrl handle
Return

TD.CheckTabEvent:
	If (cosCtlId EQ TD.TabCtrlId)
		Select Case cosCommand
			Case TCN.SELCHANGE
				Gosub TD.TabChanged
		EndSelect
		cosState = TRUE
	Else
		cosState = FALSE
	EndIf
Return

TD.IsLastPage:
	If (TD.LastPageAdded EQ TD.PageNum)
		Gosub TD.SetMainDialog
		CW.IsChildDlg = TD.MainIsChild
		cosState = TRUE
	Else
		cosState = FALSE
	EndIf
Return

TD.AddPage:
	If (TD.PageCount EQ TD.MAXPAGES)
		MsgBox "Too many pages"
		TD.PageNum = 0
		Return
	EndIf
	
	Gosub COS.TabCtrl.ItemInit
	TCItemStruc.Mask$ = INTELD(TCIF.TEXT)
	
	cosCWnd$ = TD.hWndTabCtrl$
	TCItemStruc.Text$ = CosCtlText$+NullByte$
	
	Gosub COS.TabCtrl.InsertItem
	
	! We can now calc the display area (no multi-line)
	If (TD.PageCount EQ 0) Then _
		Gosub TD.CalcPageSize

	cosCWnd$ = TD.hdlgMain$
	cosDlgFlags = DLGMODELESS + DLGISASYNC
	Gosub COS.DialogInit
	
	TD.PageCount = TD.PageCount + 1
	TD.PageNum = TD.PageCount
	TD.LastPageAdded = TD.PageNum
Return

TD.LookupPage:
	For TD.PageNum = 1 To TD.PageCount
		If (TD.hwndPages$(TD.PageNum) EQ cosCWnd$)
			Break
		EndIf
	Next TD.PageNum
Return

TD.IsPageCWnd:
	cosState = FALSE
	For TD.PageNum = 1 To TD.PageCount
		If (TD.hwndPages$(TD.PageNum) EQ cosCWnd$)
			cosState = TRUE
			Break
		EndIf
	Next TD.PageNum
Return

TD.InitPage:
	For TD.PageNum = 1 To TD.PageCount
		If (TD.hwndPages$(TD.PageNum) EQ "")
			TD.hwndPages$(TD.PageNum) = cosCWnd$

			cosWidth = TD.TabWidth
			cosHeight = TD.TabHeight
			cosCol = TD.TabCol
			cosRow = TD.TabRow
			cosDlgFlags = 0
			Gosub COS.MoveWindow
			
			! Disable OK and Cancel
			cosCtlText$ = 	Intel(ID.OK)+Intel(BN.CLICKED) + _
							Intel(ID.CANCEL)+Intel(BN.CLICKED)
			cosCWnd$ = cosDlghDlg$
			Gosub COS.AppendCmdFilter
	
			! Position after tab control
			cosDlgFlags = SWP.NOSIZE + SWP.NOMOVE + SWP.NOREDRAW
			cosCWnd$ = cosDlghDlg$
			cosItemId = IHexDec(TD.hWndTabCtrl$)
			Gosub COS.SetWindowPosEx
			Break
		EndIf
	Next TD.PageNum
Return

TD.SetInitialCtrl:
	TD.hwndFirstFocus(TD.PageNum) = cosCtlId
Return

TD.CalcPageSize:
	! Get tab control dimensions and adjust to get inner area
	cosCWnd$ = TD.hWndTabCtrl$
	Gosub COS.GetWindowRect

	! Get best fitting inside rectangle
	cosDlgFlags = FALSE
	Gosub COS.TabCtrl.AdjustRect
	TD.TabWidth = cosRight-cosLeft
	TD.TabHeight = cosBottom-cosTop

	! Convert position to dialog relative for MoveWindow	
	cosRow = cosTop
	cosCol = cosLeft
	cosCWnd$ = cosDlgHdlg$
	Gosub COS.ScreenToClient
	TD.TabCol = cosCol
	TD.TabRow = cosRow
Return

TD.DestroyTab:
	! Destroy all pages
	For TD.PageNum = 1 To TD.PageCount
		cosDlghDlg$ = TD.hwndPages$(TD.PageNum)
		Gosub COS.DestroyDialog
	Next TD.PageNum
Return

TD.EnableCurTab:
	! Show new tab
	cosCWnd$ = TD.hwndPages$(TD.CurTab)
	cosState = SW.SHOW
	Gosub COS.ShowWindow
Return

TD.TabItemFocus:
	Gosub TD.SetPageDialog
	Gosub COS.SetDlgItemFocus
	Gosub TD.SetMainDialog
Return

TD.TabChanged:

	If (TD.CurTab NE 0)
		! Hide current tab (if any)	
		cosCWnd$ = TD.hwndPages$(TD.CurTab)
		cosState = SW.HIDE
		Gosub COS.ShowWindow
	EndIf
	
	! Retrieve selected list item
	cosCWnd$ = TD.hWndTabCtrl$
	Gosub COS.TabCtrl.GetCurSel
	TD.CurTab = cosItemId+1

	Gosub TD.EnableCurTab
Return

TD.SetPage:
	cosItemId = TD.PageNum-1
	cosCWnd$ = TD.hWndTabCtrl$
	Gosub COS.TabCtrl.SetCurSel
	Gosub TD.TabChanged
Return

TD.ResetTab:
	
	! Select the first tab
	TD.PageNum = 1
	Gosub TD.SetPage

	cosCtlId = TD.hwndFirstFocus(TD.CurTab)
	Gosub TD.TabItemFocus
Return

TD.FocusFirst:
	cosCtlId = TD.hwndFirstFocus(TD.CurTab)
	Gosub TD.TabItemFocus
Return

TD.SetMainDialog:
	cosDlghDlg$ = TD.hdlgMain$	! Restore main dlg handle
Return

TD.SetPageDialog:
	If (TD.PageNum LE TD.PageCount)
		cosDlghDlg$ = TD.hwndPages$(TD.PageNum)
	Else
		MsgBox("TD.SetPageDialog: Invalid page number")
	EndIf
Return

TD.IsPageEvent:
	If (TD.hdlgMain$ NE "" And cosCWnd$ NE TD.hdlgMain$)
		cosState = TRUE
	Else
		cosState = FALSE
	Endif
Return

.ENDIF
