.IFNDEF WINDOWS.DEFINED
SET WINDOWS.DEFINED = 1

!==========================================================
!
! Window Styles
!
!==========================================================

! Basic window types
SET	WS.OVERLAPPED	= 0
SET	WS.POPUP	= 2147483648	!0x80000000L
SET	WS.CHILD	= 1073741824	!0x40000000L

! Generic window states
SET	WS.VISIBLE	= 268435456	!0x10000000L
SET	WS.DISABLED	= 134217728	!0x08000000L

SET	WS.CLIPSIBLINGS	= 67108864	!0x04000000L
SET	WS.CLIPCHILDREN = 33554432	!0x02000000L

! Main window states
SET	WS.MINIMIZE	= 536870912	!0x20000000L
SET	WS.MAXIMIZE	= 16777216	!0x01000000L

! Main window styles
SET	WS.MINIMIZEBOX	= 131072	!0x00020000
SET	WS.MAXIMIZEBOX	= 65536		!0x00010000
SET	WS.THICKFRAME	= 262144	!0x00040000
SET	WS.SYSMENU	= 524288	!0x00080000
SET	WS.HSCROLL	= 1048576	!0x00100000
SET	WS.VSCROLL	= 2097152	!0x00200000
SET	WS.DLGFRAME	= 4194304	!0x00400000
SET	WS.BORDER	= 8388608	!0x00800000
SET	WS.CAPTION	= 12582912	!0x00C00000 - (WS.BORDER | WS.DLGFRAME)

! Control window styles
SET	WS.GROUP	= 131072	!0x00020000
SET	WS.TABSTOP	= 65536		!0x00010000

! Common Window Styles

SET	WS.OVERLAPPEDWINDOW = 13565952	!0x00CF0000 - (WS.OVERLAPPED | WS.CAPTION | WS.SYSMENU | WS.THICKFRAME | WS.MINIMIZEBOX | WS.MAXIMIZEBOX)
SET	WS.POPUPWINDOW	= 2147483648	!0x80880000 - (WS.POPUP | WS.BORDER | WS.SYSMENU)
SET	WS.CHILDWINDOW	= 1073741824	!0x40000000 - (WS.CHILD)

SET	WS.TILED	= 0		! WS.OVERLAPPED
SET	WS.ICONIC	= 536870912	! WS.MINIMIZE
SET	WS.SIZEBOX	= 262144	! WS.THICKFRAME
SET	WS.TILEDWINDOW	= 13565952	! WS.OVERLAPPEDWINDOW

! Extended Window Styles
SET	WS.EX.DLGMODALFRAME	= 1	! 0x00000001
SET	WS.EX.NOPARENTNOTIFY	= 4	! 0x00000004
SET	WS.EX.TOPMOST		= 8	! 0x00000008
SET	WS.EX.ACCEPTFILES	= 16	! 0x00000010
SET	WS.EX.TRANSPARENT	= 32	! 0x00000020
SET	WS.EX.MDICHILD		= 64	! 0x00000040L
SET	WS.EX.TOOLWINDOW	= 128	! 0x00000080L
SET	WS.EX.WINDOWEDGE	= 256	! 0x00000100L
SET	WS.EX.CLIENTEDGE	= 512	! 0x00000200L
SET	WS.EX.CONTEXTHELP	= 1024	! 0x00000400L
SET	WS.EX.RIGHT		= 4096	! 0x00001000L
SET	WS.EX.LEFT		= 0	! 0x00000000L
SET	WS.EX.RTLREADING	= 8192	! 0x00002000L
SET	WS.EX.LTRREADING	= 0	! 0x00000000L
SET	WS.EX.LEFTSCROLLBAR	= 16384	! 0x00004000L
SET	WS.EX.RIGHTSCROLLBAR	= 0	! 0x00000000L
SET	WS.EX.CONTROLPARENT	= 65536	! 0x00010000L
SET	WS.EX.STATICEDGE	= 131072 ! 0x00020000L
SET	WS.EX.APPWINDOW		= 262144 ! 0x00040000L
SET	WS.EX.OVERLAPPEDWINDOW	= 768	! (WS.EX.WINDOWEDGE | WS.EX.CLIENTEDGE)
SET	WS.EX.PALETTEWINDOW	= 392	! (WS.EX.WINDOWEDGE | WS.EX.TOOLWINDOW | WS.EX.TOPMOST)


! Mouse support
! Mouse input messages
SET	WM.MOUSEMOVE	 = 512	!0x0200
SET	WM.LBUTTONDOWN	 = 513	!0x0201
SET	WM.LBUTTONUP	 = 514	!0x0202
SET	WM.LBUTTONDBLCLK = 515	!0x0203
SET	WM.RBUTTONDOWN	 = 516	!0x0204
SET	WM.RBUTTONUP	 = 517	!0x0205
SET	WM.RBUTTONDBLCLK = 518	!0x0206
SET	WM.MBUTTONDOWN	 = 519	!0x0207
SET	WM.MBUTTONUP	 = 520	!0x0208
SET	WM.MBUTTONDBLCLK = 521	!0x0209

! Mouse input message range
SET	WM.MOUSEFIRST	 = 512	!0x0200
SET	WM.MOUSELAST	 = 521	!0x0209

! Mouse message wParam key states
SET	MK.LBUTTON	 = 1	!0x0001
SET	MK.RBUTTON	 = 2	!0x0002
SET	MK.SHIFT	 = 4	!0x0004
SET	MK.CONTROL	 = 8	!0x0008
SET	MK.MBUTTON	 = 16	!0x0010


!==========================================================
!
! Type values for the MessageBox function
!
!==========================================================
SET	MB.OK		   	= 0	! 0x00000000L
SET	MB.OKCANCEL	   	= 1	! 0x00000001L
SET	MB.ABORTRETRYIGNORE	= 2	! 0x00000002L
SET	MB.YESNOCANCEL		= 3	! 0x00000003L
SET	MB.YESNO		= 4	! 0x00000004L
SET	MB.RETRYCANCEL	   	= 5	! 0x00000005L

SET	MB.ICONHAND	   	= 16	! MB.ICONSTOP
SET	MB.ICONQUESTION	   	= 32	! 0x00000020L
SET	MB.ICONEXCLAMATION 	= 48	! 0x00000030L
SET	MB.ICONASTERISK	   	= 64	! MB.ICONINFORMATION

SET	MB.USERICON		= 128	! 0x00000080L
SET	MB.ICONWARNING		= 48	! MB.ICONEXCLAMATION
SET	MB.ICONERROR		= 16	! MB.ICONHAND

SET	MB.ICONINFORMATION 	= 64	! MB.ICONASTERISK
SET	MB.ICONSTOP	   	= 16	! MB.ICONHAND

SET	MB.DEFBUTTON1	   	= 0	! 0x00000000L
SET	MB.DEFBUTTON2	   	= 256	! 0x00000100L
SET	MB.DEFBUTTON3	   	= 512	! 0x00000200L
SET	MB.DEFBUTTON4	   	= 768	! 0x00000300L

SET	MB.APPLMODAL	   	= 0	! 0x00000000L
SET	MB.SYSTEMMODAL	   	= 4096	! 0x00001000L
SET	MB.TASKMODAL	   	= 8192	! 0x00002000L
SET	MB.HELP		   	= 16384	! 0x00004000L

SET	MB.NOFOCUS	   	= 32768	! 0x00008000L
SET	MB.SETFOREGROUND   	= 65536	! 0x00010000L
SET	MB.DEFAULT.DESKTOP.ONLY	= 131072 ! 0x00020000L

SET	MB.TOPMOST	   	= 262144 ! 0x00040000L
SET	MB.RIGHT	   	= 524288 ! 0x00080000L
SET	MB.RTLREADING	   	= 1048576 ! 0x00100000L

SET	MB.TYPEMASK	   	= 15	! 0x0000000FL
SET	MB.ICONMASK	   	= 240	! 0x000000F0L
SET	MB.DEFMASK	   	= 3840	! 0x00000F00L
SET	MB.MODEMASK	   	= 12288	! 0x00003000L
SET	MB.MISCMASK	   	= 49152	! 0x0000C000L

!==========================================================
! These are standard ID's assigned by MFC and used
! in many dialogs that have an OK and CANCEL button
!==========================================================
SET	ID.OK			= 1
SET	IDOK			= 1
SET	ID.CANCEL	= 2
SET	IDCANCEL		= 2
SET	ID.ABORT		= 3
SET	IDABORT		= 3
SET	ID.RETRY		= 4
SET	IDRETRY		= 4
SET	ID.IGNORE	= 5
SET	IDIGNORE		= 5
SET	ID.YES		= 6
SET	IDYES			= 6
SET	ID.NO			= 7
SET	IDNO			= 7
SET	ID.CLOSE		= 8
SET	IDCLOSE		= 8
SET	ID.HELP		= 9
SET	IDHELP		= 9

!====================================
! Windows WM. messages
!====================================
SET	WM.INITDIALOG		= 272
SET	WM.COMMAND		= 273
SET	WM.SYSCOMMAND		= 274
SET	WM.TIMER		= 275
SET	WM.HSCROLL		= 276
SET	WM.VSCROLL		= 277

SET	WM.USER			= 1024
SET	WM.PAINTICON            = 38
SET	WM.ICONERASEBKGND       = 39
SET	WM.NEXTDLGCTL		= 40
SET	WM.SPOOLERSTATUS        = 42
SET	WM.DRAWITEM             = 43
SET	WM.MEASUREITEM          = 44
SET	WM.DELETEITEM           = 45
SET	WM.VKEYTOITEM		= 46
SET	WM.CHARTOITEM		= 47
SET	WM.SETFONT              = 48
SET	WM.GETFONT              = 49
SET	WM.SETHOTKEY            = 50
SET	WM.GETHOTKEY            = 51
SET	WM.QUERYDRAGICON        = 55
SET	WM.COMPAREITEM          = 57

SET	WM.NOTIFY					= 78

SET	WM.DESTROY		= 2
SET	WM.SIZE			= 5
SET	WM.SETTEXT		= 12
SET	WM.GETTEXT		= 13
SET	WM.GETTEXTLENGTH	= 14

SET	SIZE.RESTORED		= 0
SET	SIZE.MINIMIZED		= 1
SET	SIZE.MAXIMIZED		= 2
SET	SIZE.MAXSHOW		= 3
SET	SIZE.MAXHIDE		= 4


! GetWindowLong & SetWindowLong Values
Set GWL.EXSTYLE		= 4294967276		! FFFFFFEC (-20) Retrieves the extended window styles. For more information, see CreateWindowEx.
Set GWL.STYLE			= 4294967280		! FFFFFFF0 (-16) Retrieves the window styles.
Set GWL.WNDPROC		= 4294967292		! FFFFFFFC (-4) Retrieves the address of the window procedure, or a handle representing the address of the window procedure. You must use the CallWindowProc function to call the window procedure.
Set GWL.HINSTANCE		= 4294967290		! FFFFFFFA (-6) Retrieves a handle to the application instance.
Set GWL.HWNDPARENT	= 4294967288		! FFFFFFF8 (-8) Retrieves a handle to the parent window, if any.
Set GWL.ID				= 4294967284		! FFFFFFF4 (-12) Retrieves the identifier of the window.
Set GWL.USERDATA		= 4294967275		! FFFFFFEB (-21) Retrieves the user data associated with the window. This data is intended for use by the application that created the window. Its value is initially zero.


! ShowWindow values
SET	SW.HIDE			= 0
SET	SW.SHNORMAL		= 1
SET	SW.NORMAL		= 1
SET	SW.SHMINIMIZE		= 2
SET	SW.SHMAXIMIZE		= 3
SET	SW.MAXIMIZE		= 3
SET	SW.SHNOACTIVATE		= 4
SET	SW.SHOW			= 5
SET	SW.MINIMIZE		= 6
SET	SW.SHMINNOACTIVATE	= 7
SET	SW.SHNA			= 8
SET	SW.RESTORE		= 9
SET	SW.SHOWDEFAULT		= 10

! SetWindowPos HWND InsertAfter field values
SET	HWND.BOTTOM		= 0
SET	HWND.TOP		= 1
SET	HWND.TOPMOST		= 65535		! (-1)
SET	HWND.NOTOPMOST		= 65534		! (-2)

! SetWindowPos and WINDOWPOS flags
SET	SWP.NOSIZE		= 1		! INTEL(&h0001)
SET	SWP.NOMOVE		= 2		! INTEL(&h0002)
SET	SWP.NOZORDER		= 4		! INTEL(&h0004)
SET	SWP.NOREDRAW		= 8		! INTEL(&h0008)
SET	SWP.NOACTIVATE		= 16		! INTEL(&h0010)
SET	SWP.DRAWFRAME		= 32		! INTEL(&h0020)
SET	SWP.FRAMECHANGED	= 32		! INTEL(&h0020)
SET	SWP.SHOWWINDOW		= 64		! INTEL(&h0040)
SET	SWP.HIDEWINDOW		= 128		! INTEL(&h0080)
SET	SWP.NOCOPYBITS		= 256		! INTEL(&h0100)
SET	SWP.NOOWNERZORDER	= 512		! INTEL(&h0200)
SET	SWP.NOREPOSITION	= 512		! INTEL(&h0200)
SET	SWP.NOSENDCHANGING	= 1024		! INTEL(&h0400)

!====================================
! Toolbar messages
!====================================
SET	TB.ENABLEBUTTON			= 1025
SET	TB.CHECKBUTTON				= 1026
SET	TB.PRESSBUTTON				= 1027
SET	TB.HIDEBUTTON				= 1028
SET	TB.INDETERMINATE			= 1029
SET	TB.ISBUTTONENABLED		= 1033
SET	TB.ISBUTTONCHECKED		= 1034
SET	TB.ISBUTTONPRESSED		= 1035
SET	TB.ISBUTTONHIDDEN			= 1036
SET	TB.ISBUTTONINDETERMINATE = 1037
SET	TB.SETSTATE					= 1041
SET	TB.GETSTATE					= 1042
SET	TB.BUTTONCOUNT				= 1048
SET	TB.COMMANDTOINDEX			= 1049

!====================================
! Combo box messages
!====================================
SET	CB.GETEDITSEL		= 320		! INTEL(&h0140)
SET	CB.LIMITTEXT		= 321		! INTEL(&h0141)
SET	CB.SETEDITSEL		= 322		! INTEL(&h0142)
SET	CB.ADDSTRING		= 323		! INTEL(&h0143)
SET	CB.DELETESTRING		= 324		! INTEL(&h0144)
SET	CB.DIR			= 325		! INTEL(&h0145)
SET	CB.GETCOUNT		= 326		! INTEL(&h0146)
SET	CB.GETCURSEL		= 327		! INTEL(&h0147)
SET	CB.GETLBTEXT		= 328		! INTEL(&h0148)
SET	CB.GETLBTEXTLEN		= 329		! INTEL(&h0149)
SET	CB.INSERTSTRING		= 330		! INTEL(&h014A)
SET	CB.RESETCONTENT		= 331		! INTEL(&h014B)
SET	CB.FINDSTRING		= 332		! INTEL(&h014C)
SET	CB.SELECTSTRING		= 333		! INTEL(&h014D)
SET	CB.SETCURSEL		= 334		! INTEL(&h014E)
SET	CB.SHOWDROPDOWN		= 335		! INTEL(&h014F)
SET	CB.GETITEMDATA		= 336		! INTEL(&h0150)
SET	CB.SETITEMDATA		= 337		! INTEL(&h0151)
SET	CB.GETDROPPEDCONTROLRECT= 338		! INTEL(&h0152)
SET	CB.SETITEMHEIGHT	= 339		! INTEL(&h0153)
SET	CB.GETITEMHEIGHT	= 340		! INTEL(&h0154)
SET	CB.SETEXTENDEDUI	= 341		! INTEL(&h0155)
SET	CB.GETEXTENDEDUI	= 342		! INTEL(&h0156)
SET	CB.GETDROPPEDSTATE	= 343		! INTEL(&h0157)
SET	CB.FINDSTRINGEXACT	= 344		! INTEL(&h0158)
SET	CB.SETLOCALE		= 345		! INTEL(&h0159)
SET	CB.GETLOCALE		= 346		! INTEL(&h015A)
SET	CB.GETTOPINDEX		= 347		! INTEL(&h015B)
SET	CB.SETTOPINDEX		= 348		! INTEL(&h015C)
SET	CB.GETHORIZONTALEXTENT	= 349		! INTEL(&h015D)
SET	CB.SETHORIZONTALEXTENT	= 350		! INTEL(&h015E)
SET	CB.GETDROPPEDWIDTH	= 351		! INTEL(&h015F)
SET	CB.SETDROPPEDWIDTH	= 352		! INTEL(&h0160)
SET	CB.INITSTORAGE		= 353		! INTEL(&h0161)

!====================================
! Combo box message return values
!====================================
SET	CB.OKAY			= 0		! INTEL(&h0000)
SET	CB.ERR			= 65535		! INTEL(&hFFFF)
SET	CB.ERRSPACE		= 65534		! INTEL(&hFFFE)

!====================================
! Combo box notification codes
!====================================
SET	CBN.ERRSPACE		= 65535		! (-1)
SET	CBN.SELCHANGE		= 1
SET	CBN.DBLCLK			= 2
SET	CBN.SETFOCUS		= 3
SET	CBN.KILLFOCUS		= 4
SET	CBN.EDITCHANGE		= 5
SET	CBN.EDITUPDATE		= 6
SET	CBN.DROPDOWN		= 7
SET	CBN.CLOSEUP			= 8
SET	CBN.SELENDOK		= 9
SET	CBN.SELENDCANCEL	= 10

!====================================
! Combo box styles
!====================================
SET	CBS.SIMPLE		= 1	! INTELD(&h0001)
SET	CBS.DROPDOWN		= 2	! INTELD(&h0002)
SET	CBS.DROPDOWNLIST	= 3	! INTELD(&h0003)
SET	CBS.OWNERDRAWFIXED	= 16	! INTELD(&h0010)
SET	CBS.OWNERDRAWVARIABLE	= 32	! INTELD(&h0020)
SET	CBS.AUTOHSCROLL		= 64	! INTELD(&h0040)
SET	CBS.OEMCONVERT		= 128	! INTELD(&h0080)
SET	CBS.SORT		= 256	! INTELD(&h0100)
SET	CBS.HASSTRINGS		= 512	! INTELD(&h0200)
SET	CBS.NOINTEGRALHEIGHT	= 1024	! INTELD(&h0400)
SET	CBS.DISABLENOSCROLL	= 2048	! INTELD(&h0800)
SET	CBS.UPPERCASE		= 8192	! INTELD(&h2000)
SET	CBS.LOWERCASE		= 16384	! INTELD(&h4000)


!====================================
! List box messages
!====================================
SET	LB.ADDSTRING		= 384		! INTEL(&h0180)
SET	LB.INSERTSTRING		= 385		! INTEL(&h0181)
SET	LB.DELETESTRING		= 386		! INTEL(&h0182)
SET	LB.SELITEMRANGEEX	= 387		! INTEL(&h0183)
SET	LB.RESETCONTENT		= 388		! INTEL(&h0184)
SET	LB.SETSEL		= 389		! INTEL(&h0185)
SET	LB.SETCURSEL		= 390		! INTEL(&h0186)
SET	LB.GETSEL		= 391		! INTEL(&h0187)
SET	LB.GETCURSEL		= 392		! INTEL(&h0188)
SET	LB.GETTEXT		= 393		! INTEL(&h0189)
SET	LB.GETTEXTLEN		= 394		! INTEL(&h018A)
SET	LB.GETCOUNT		= 395		! INTEL(&h018B)
SET	LB.SELECTSTRING		= 396		! INTEL(&h018C)
SET	LB.DIR			= 397		! INTEL(&h018D)
SET	LB.GETTOPINDEX		= 398		! INTEL(&h018E)
SET	LB.FINDSTRING		= 399		! INTEL(&h018F)
SET	LB.GETSELCOUNT		= 400		! INTEL(&h0190)
SET	LB.GETSELITEMS		= 401		! INTEL(&h0191)
SET	LB.SETTABSTOPS		= 402		! INTEL(&h0192)
SET	LB.GETHORIZONTALEXTENT	= 403		! INTEL(&h0193)
SET	LB.SETHORIZONTALEXTENT	= 404		! INTEL(&h0194)
SET	LB.SETCOLUMNWIDTH	= 405		! INTEL(&h0195)
SET	LB.ADDFILE		= 406		! INDEL(&h0196)
SET	LB.SETTOPINDEX		= 407		! INTEL(&h0197)
SET	LB.GETITEMRECT		= 408		! INTEL(&h0198)
SET	LB.GETITEMDATA		= 409		! INTEL(&h0199)
SET	LB.SETITEMDATA		= 410		! INTEL(&h019A)
SET	LB.SELITEMRANGE		= 411		! INTEL(&h019B)
SET	LB.SETANCHORINDEX	= 412		! INTEL(&h019C)
SET	LB.GETANCHORINDEX	= 413		! INTEL(&h019D)
SET	LB.SETCARETINDEX	= 414		! INTEL(&h019E)
SET	LB.GETCARETINDEX	= 415		! INTEL(&h019F)
SET	LB.SETITEMHEIGHT	= 416		! INTEL(&h01A0)
SET	LB.GETITEMHEIGHT	= 417		! INTEL(&h01A1)
SET	LB.FINDSTRINGEXACT	= 418		! INTEL(&h01A2)
SET	LB.SETLOCALE		= 419		! INTEL(&h01A3)
SET	LB.GETLOCALE		= 420		! INTEL(&h01A4)
SET	LB.SETCOUNT		= 421		! INTEL(&h01A5)
SET	LB.INITSTORAGE		= 422		! INTEL(&h01A6)
SET	LB.ITEMFROMPOINT	= 423		! INTEL(&h01A7)

!====================================
! Listbox message return values
!====================================
SET	LB.OKAY			= 0		! INTEL(0)
SET	LB.ERR			= 65535		! INTEL(-1)
SET	LB.ERRSPACE		= 65534		! INTEL(-2)

SET	LB.CTLCODE		= 0		! INTELD(0)

!====================================
! Listbox notification codes
!====================================
SET	LBN.ERRSPACE		= 65534		! (-2)
SET	LBN.SELCHANGE		= 1
SET	LBN.DBLCLK			= 2
SET	LBN.SELCANCEL		= 3
SET	LBN.SETFOCUS		= 4
SET	LBN.KILLFOCUS		= 5

!====================================
! Listbox styles
!====================================
SET	LBS.NOTIFY		= 1	! INTELD(&h00000001)
SET	LBS.SORT		= 2	! INTELD(&h00000002)
SET	LBS.NOREDRAW		= 4	! INTELD(&h00000004)
SET	LBS.MULTIPLESEL		= 8	! INTELD(&h00000008)
SET	LBS.OWNERDRAWFIXED	= 16	! INTELD(&h00000010)
SET	LBS.OWNERDRAWVARIABLE	= 32	! INTELD(&h00000020)
SET	LBS.HASSTRINGS		= 64	! INTELD(&h00000040)
SET	LBS.USETABSTOPS		= 128	! INTELD(&h00000080)
SET	LBS.NOINTEGRALHEIGHT	= 256	! INTELD(&h00000100)
SET	LBS.MULTICOLUMN		= 512	! INTELD(&h00000200)
SET	LBS.WANTKEYBOARDINPUT	= 1024	! INTELD(&h00000400)
SET	LBS.EXTENDEDSEL		= 2048	! INTELD(&h00000800)
SET	LBS.DISABLENOSCROLL	= 4096	! INTELD(&h00001000)
SET	LBS.NOSEL		= 16384	! INTELD(&h00004000)
SET	LBS.STANDARD		= 10485763 ! INTELD(&h00A00003)


!====================================
! Edit control messages
!====================================
SET	EM.GETSEL		= 176		! INTEL(&h00B0)
SET	EM.SETSEL		= 177		! INTEL(&h00B1)
SET	EM.GETRECT		= 178		! INTEL(&h00B2)
SET	EM.SETRECT		= 179		! INTEL(&h00B3)
SET	EM.SETRECTNP		= 180		! INTEL(&h00B4)
SET	EM.SCROLL               = 181		! INTEL(&h00B5)
SET	EM.LINESCROLL		= 182		! INTEL(&h00B6)
SET	EM.SCROLLCARET          = 183		! INTEL(&h00B7)
SET	EM.GETMODIFY		= 184		! INTEL(&h00B8)
SET	EM.SETMODIFY		= 185		! INTEL(&h00B9)
SET	EM.GETLINECOUNT		= 186		! INTEL(&h00BA)
SET	EM.LINEINDEX		= 187		! INTEL(&h00BB)
SET	EM.SETHANDLE		= 188		! INTEL(&h00BC)
SET	EM.GETHANDLE		= 189		! INTEL(&h00BD)
SET	EM.GETTHUMB             = 190		! INTEL(&h00BE)

SET	EM.LINELENGTH		= 193		! INTEL(&h00C1)
SET	EM.REPLACESEL		= 194		! INTEL(&h00C2)
SET	EM.GETLINE		= 196		! INTEL(&h00C4)
SET	EM.LIMITTEXT		= 197		! INTEL(&h00C5)
SET	EM.CANUNDO		= 198		! INTEL(&h00C6)
SET	EM.UNDO			= 199		! INTEL(&h00C7)
SET	EM.FMTLINES		= 200		! INTEL(&h00C8)
SET	EM.LINEFROMCHAR		= 201		! INTEL(&h00C9)
SET	EM.SETTABSTOPS		= 203		! INTEL(&h00CB)
SET	EM.SETPASSWORDCHAR	= 204		! INTEL(&h00CC)
SET	EM.EMPTYUNDOBUFFER	= 205		! INTEL(&h00CD)
SET	EM.GETFIRSTVISIBLELINE	= 206		! INTEL(&h00CE)
SET	EM.SETREADONLY		= 207		! INTEL(&h00CF)
SET	EM.SETWORDBREAKPROC	= 208		! INTEL(&h00D0)
SET	EM.GETWORDBREAKPROC	= 209		! INTEL(&h00D1)
SET	EM.GETPASSWORDCHAR	= 210		! INTEL(&h00D2)
SET	EM.SETMARGINS		= 211		! INTEL(&h00D3)
SET	EM.GETMARGINS		= 212		! INTEL(&h00D4)
SET	EM.SETLIMITTEXT		= 197		! EM.LIMITTEXT   /* ;win40 Name change */
SET	EM.GETLIMITTEXT		= 213		! INTEL(&h00D5)
SET	EM.POSFROMCHAR		= 214		! INTEL(&h00D6)
SET	EM.CHARFROMPOS		= 215		! INTEL(&h00D7)

!====================================
! Edit control notify codes
!====================================
SET	EN.SETFOCUS		= 256	! INTEL(&h0100)
SET	EN.KILLFOCUS	= 512	! INTEL(&h0200)
SET	EN.CHANGE		= 768	! INTEL(&h0300)
SET	EN.UPDATE		= 1024	! INTEL(&h0400)
SET	EN.ERRSPACE		= 1280	! INTEL(&h0500)
SET	EN.MAXTEXT		= 1281	! INTEL(&h0501)
SET	EN.HSCROLL		= 1537	! INTEL(&h0601)
SET	EN.VSCROLL		= 1538	! INTEL(&h0602)

!====================================
! Edit control EM.SETMARGIN parameters
!====================================
SET	EC.LEFTMARGIN		= 1	! INTEL(&h0001)
SET	EC.RIGHTMARGIN		= 2	! INTEL(&h0002)
SET	EC.USEFONTINFO		= 65535	! INTEL(&hffff)

!====================================
! Edit control styles
!====================================
SET	ES.LEFT			= 0		! INTELD(&h0000)
SET	ES.CENTER		= 1		! INTELD(&h0001)
SET	ES.RIGHT			= 2		! INTELD(&h0002)
SET	ES.MULTILINE	= 4		! INTELD(&h0004)
SET	ES.UPPERCASE	= 8		! INTELD(&h0008)
SET	ES.LOWERCASE	= 16		! INTELD(&h0010)
SET	ES.PASSWORD		= 32		! INTELD(&h0020)
SET	ES.AUTOVSCROLL	= 64		! INTELD(&h0040)
SET	ES.AUTOHSCROLL	= 128		! INTELD(&h0080)
SET	ES.NOHIDESEL	= 256		! INTELD(&h0100)
SET	ES.OEMCONVERT	= 1024	! INTELD(&h0400)
SET	ES.READONLY		= 2048	! INTELD(&h0800)
SET	ES.WANTRETURN	= 4096	! INTELD(&h1000)
SET	ES.NUMBER		= 8192	! INTELD(&h2000)

!====================================
! Static control messages
!====================================
SET	STM.SETICON		= 368	! INTEL(&h0170)
SET	STM.GETICON		= 369	! INTEL(&h0171)
SET	STM.SETIMAGE		= 370 	! INTEL(&h0172)
SET	STM.GETIMAGE		= 371 	! INTEL(&h0173)
SET	STN.CLICKED		= 0
SET	STN.DBLCLK		= 1
SET	STN.ENABLE		= 2
SET	STN.DISABLE		= 3
SET	STN.RCLICKED		= 4	! Invented 1/11/00 by Brian

!====================================
! Static control styles
!====================================
SET	SS.LEFT			= 0	! INTELD(&h0000)
SET	SS.CENTER		= 1	! INTELD(&h0001)
SET	SS.RIGHT		= 2	! INTELD(&h0002)
SET	SS.ICON			= 3	! INTELD(&h0003)
SET	SS.BLACKRECT		= 4	! INTELD(&h0004)
SET	SS.GRAYRECT		= 5	! INTELD(&h0005)
SET	SS.WHITERECT		= 6	! INTELD(&h0006)
SET	SS.BLACKFRAME		= 7	! INTELD(&h0007)
SET	SS.GRAYFRAME		= 8	! INTELD(&h0008)
SET	SS.WHITEFRAME		= 9	! INTELD(&h0009)
SET	SS.USERITEM		= 10	! INTELD(&h000A)
SET	SS.SIMPLE		= 11	! INTELD(&h000B)
SET	SS.LEFTNOWORDWRAP	= 12	! INTELD(&h000C)

SET	SS.OWNERDRAW		= 13	! INTELD(&h000D)
SET	SS.BITMAP		= 14	! INTELD(&h000E)
SET	SS.ENHMETAFILE		= 15	! INTELD(&h000F)
SET	SS.ETCHEDHORZ		= 16	! INTELD(&h0010)
SET	SS.ETCHEDVERT		= 17	! INTELD(&h0011)
SET	SS.ETCHEDFRAME		= 18	! INTELD(&h0012)
SET	SS.TYPEMASK		= 31	! INTELD(&h001F)

SET	SS.NOPREFIX		= 128	! INTELD(&h0080)

SET	SS.NOTIFY		= 256	! INTELD(&h0100)
SET	SS.CENTERIMAGE		= 512	! INTELD(&h0200)
SET	SS.RIGHTJUST		= 1024	! INTELD(&h0400)
SET	SS.REALSIZEIMAGE	= 2048	! INTELD(&h0800)
SET	SS.SUNKEN		= 4096	! INTELD(&h1000)
SET	SS.ENDELLIPSIS		= 16384	! INTELD(&h4000)
SET	SS.PATHELLIPSIS		= 32768	! INTELD(&h8000)
SET	SS.WORDELLIPSIS		= 49152	! INTELD(&hC000)
SET	SS.ELLIPSISMASK		= 49152	! INTELD(&hC000)


!====================================
! Button control messages
!====================================
SET	BM.GETCHECK		= 240	! INTEL(&h00F0)
SET	BM.SETCHECK		= 241	! INTEL(&h00F1)
SET	BM.GETSTATE		= 242	! INTEL(&h00F2)
SET	BM.SETSTATE		= 243	! INTEL(&h00F3)
SET	BM.SETSTYLE		= 244	! INTEL(&h00F4)
SET	BM.CLICK		= 245	! INTEL(&h00F5)
SET	BM.GETIMAGE		= 246	! INTEL(&h00F6)
SET	BM.SETIMAGE		= 247	! INTEL(&h00F7)

SET	BST.UNCHECKED		= 0	! INTEL(&h0000)
SET	BST.CHECKED		= 1	! INTEL(&h0001)
SET	BST.INDETERMINATE	= 2	! INTEL(&h0002)
SET	BST.PUSHED		= 4	! INTEL(&h0004)
SET	BST.FOCUS		= 8	! INTEL(&h0008)

!====================================
! Button control notify codes
!====================================
SET	BN.CLICKED		= 0
SET	BN.PAINT		= 1
SET	BN.HILITE		= 2
SET	BN.UNHILITE		= 3
SET	BN.DISABLE		= 4
SET	BN.DOUBLECLICKED	= 5
SET	BN.PUSHED		= 2	! BN.HILITE
SET	BN.UNPUSHED		= 3	! BN.UNHILITE
SET	BN.DBLCLK		= 5	! BN.DOUBLECLICKED
SET	BN.SETFOCUS		= 6
SET	BN.KILLFOCUS		= 7


!====================================
! Button control styles
!====================================
SET	BS.PUSHBUTTON		= 0	! INTELD(&h0000)
SET	BS.DEFPUSHBUTTON	= 1	! INTELD(&h0001)
SET	BS.CHECKBOX		= 2	! INTELD(&h0002)
SET	BS.AUTOCHECKBOX		= 3	! INTELD(&h0003)
SET	BS.RADIOBUTTON		= 4	! INTELD(&h0004)
SET	BS.3STATE		= 5	! INTELD(&h0005)
SET	BS.AUTO3STATE		= 6	! INTELD(&h0006)
SET	BS.GROUPBOX		= 7	! INTELD(&h0007)
SET	BS.USERBUTTON		= 8	! INTELD(&h0008)
SET	BS.AUTORADIOBUTTON	= 9	! INTELD(&h0009)
SET	BS.OWNERDRAW		= 11	! INTELD(&h000B)
SET	BS.LEFTTEXT		= 32	! INTELD(&h0020)
SET	BS.TEXT			= 0	! INTELD(&h0000)
SET	BS.ICON			= 64	! INTELD(&h0040)
SET	BS.BITMAP		= 128	! INTELD(&h0080)
SET	BS.LEFT			= 256	! INTELD(&h0100)
SET	BS.RIGHT		= 512	! INTELD(&h0200)
SET	BS.CENTER		= 768	! INTELD(&h0300)
SET	BS.TOP			= 1024	! INTELD(&h0400)
SET	BS.BOTTOM		= 2048	! INTELD(&h0800)
SET	BS.VCENTER		= 3072	! INTELD(&h0C00)
SET	BS.PUSHLIKE		= 4096	! INTELD(&h1000)
SET	BS.MULTILINE		= 8192	! INTELD(&h2000)
SET	BS.NOTIFY		= 16384	! INTELD(&h4000)
SET	BS.FLAT			= 32768	! INTELD(&h8000)
SET	BS.RIGHTBUTTON		= 32	! BS.LEFTTEXT

!====================================
! Flags for Keyboard functions
!====================================
SET	FVIRTKEY  		= 1	! Assumed to be == TRUE == 1
SET	FNOINVERT 		= 2
SET	FSHIFT    		= 4
SET	FCONTROL  		= 8
SET	FALT      		= 16

!====================================
! Virtual key codes
!====================================
SET	VK.LBUTTON        	= 1
SET	VK.RBUTTON        	= 2
SET	VK.CANCEL         	= 3
SET	VK.MBUTTON        	= 4    ! NOT contiguous with L & RBUTTON

SET	VK.BACK           	= 8
SET	VK.TAB            	= 9

SET	VK.CLEAR          	= 12
SET	VK.RETURN         	= 13

SET	VK.SHIFT          	= 16
SET	VK.CONTROL        	= 17
SET	VK.MENU           	= 18
SET	VK.PAUSE          	= 19
SET	VK.CAPITAL        	= 20


SET	VK.ESCAPE         	= 27

SET	VK.SPACE          	= 32
SET	VK.PRIOR          	= 33
SET	VK.NEXT           	= 34
SET	VK.END            	= 35
SET	VK.HOME           	= 36
SET	VK.LEFT           	= 37
SET	VK.UP             	= 38
SET	VK.RIGHT          	= 39
SET	VK.DOWN           	= 40
SET	VK.SELECT         	= 41
SET	VK.PRINT          	= 42
SET	VK.EXECUTE        	= 43
SET	VK.SNAPSHOT       	= 44
SET	VK.INSERT         	= 45
SET	VK.DELETE         	= 46
SET	VK.HELP           	= 47

! VK.0 thru VK.9 are the same as ASCII '0' thru '9' (48 - 57)
! VK.A thru VK.Z are the same as ASCII 'A' thru 'Z' (65 - 90)

SET	VK.LWIN           	= 91
SET	VK.RWIN           	= 92
SET	VK.APPS           	= 93

SET	VK.NUMPAD0        	= 96
SET	VK.NUMPAD1        	= 97
SET	VK.NUMPAD2        	= 98
SET	VK.NUMPAD3        	= 99
SET	VK.NUMPAD4        	= 100
SET	VK.NUMPAD5        	= 101
SET	VK.NUMPAD6        	= 102
SET	VK.NUMPAD7        	= 103
SET	VK.NUMPAD8        	= 104
SET	VK.NUMPAD9        	= 105
SET	VK.MULTIPLY       	= 106
SET	VK.ADD            	= 107
SET	VK.SEPARATOR      	= 108
SET	VK.SUBTRACT       	= 109
SET	VK.DECIMAL        	= 110
SET	VK.DIVIDE         	= 111
SET	VK.F1             	= 112
SET	VK.F2             	= 113
SET	VK.F3             	= 114
SET	VK.F4             	= 115
SET	VK.F5             	= 116
SET	VK.F6             	= 117
SET	VK.F7             	= 118
SET	VK.F8             	= 119
SET	VK.F9             	= 120
SET	VK.F10            	= 121
SET	VK.F11            	= 122
SET	VK.F12            	= 123
SET	VK.F13            	= 124
SET	VK.F14            	= 125
SET	VK.F15            	= 126
SET	VK.F16            	= 127
SET	VK.F17            	= 128
SET	VK.F18            	= 129
SET	VK.F19            	= 130
SET	VK.F20            	= 131
SET	VK.F21            	= 132
SET	VK.F22            	= 133
SET	VK.F23            	= 134
SET	VK.F24            	= 135

SET	VK.NUMLOCK        	= 144
SET	VK.SCROLL         	= 145

!
! VK.L* & VK.R* - left and right Alt, Ctrl and Shift virtual keys.
! Used only as parameters to GetAsyncKeyState() and GetKeyState().
! No other API or message will distinguish left and right keys in this way.
!
SET	VK.LSHIFT         	= 160
SET	VK.RSHIFT         	= 161
SET	VK.LCONTROL       	= 162
SET	VK.RCONTROL       	= 163
SET	VK.LMENU          	= 164
SET	VK.RMENU          	= 165

SET	VK.PROCESSKEY     	= 229

SET	VK.ATTN           	= 246
SET	VK.CRSEL          	= 247
SET	VK.EXSEL          	= 248
SET	VK.EREOF          	= 249
SET	VK.PLAY           	= 250
SET	VK.ZOOM           	= 251
SET	VK.NONAME         	= 252
SET	VK.PA1            	= 253
SET	VK.OEM.CLEAR      	= 254


!====================================
! Flags for TrackPopupMenu
!====================================
SET	TPM.LEFTBUTTON		= 0	! INTEL(&h0000)
SET	TPM.RIGHTBUTTON		= 2	! INTEL(&h0002)
SET	TPM.LEFTALIGN		= 0	! INTEL(&h0000)
SET	TPM.CENTERALIGN		= 4	! INTEL(&h0004)
SET	TPM.RIGHTALIGN		= 8	! INTEL(&h0008)
SET	TPM.TOPALIGN		= 0	! INTEL(&h0000)
SET	TPM.VCENTERALIGN	= 16	! INTEL(&h0010)
SET	TPM.BOTTOMALIGN		= 32	! INTEL(&h0020)

SET	TPM.HORIZONTAL		= 0	! INTEL(&h0000)	Horz alignment matters more
SET	TPM.VERTICAL		= 64	! INTEL(&h0040) Vert alignment matters more
SET	TPM.NONOTIFY		= 128	! INTEL(&h0080) Don't send any notification msgs
SET	TPM.RETURNCMD		= 256	! INTEL(&h0100)

!====================================
! Flags for Add/Check/EnableMenuItem
!====================================

SET	MF.INSERT           	= 0
SET	MF.CHANGE           	= 128
SET	MF.APPEND           	= 256
SET	MF.DELETE           	= 512
SET	MF.REMOVE           	= 4096

SET	MF.BYCOMMAND        	= 0
SET	MF.BYPOSITION       	= 1024

SET	MF.SEPARATOR        	= 2048

SET	MF.ENABLED          	= 0
SET	MF.GRAYED           	= 1
SET	MF.DISABLED         	= 2

SET	MF.UNCHECKED        	= 0
SET	MF.CHECKED          	= 8
SET	MF.USECHECKBITMAPS  	= 512

SET	MF.STRING           	= 0
SET	MF.BITMAP           	= 40
SET	MF.OWNERDRAW        	= 256

SET	MF.POPUP            	= 16
SET	MF.MENUBARBREAK     	= 32
SET	MF.MENUBREAK        	= 64

SET	MF.UNHILITE         	= 0
SET	MF.HILITE           	= 128

SET	MF.DEFAULT          	= 4096
SET	MF.SYSMENU          	= 8192
SET	MF.HELP             	= 16384
SET	MF.RIGHTJUSTIFY     	= 16384

SET	MF.MOUSESELECT      	= 32768


SET	MFT.STRING          	= 0	! MF.STRING
SET	MFT.BITMAP          	= 40	! MF.BITMAP
SET	MFT.MENUBARBREAK    	= 32	! MF.MENUBARBREAK
SET	MFT.MENUBREAK       	= 64	! MF.MENUBREAK
SET	MFT.OWNERDRAW       	= 256	! MF.OWNERDRAW
SET	MFT.RADIOCHECK      	= 512
SET	MFT.SEPARATOR       	= 2048	! MF.SEPARATOR
SET	MFT.RIGHTORDER      	= 8192
SET	MFT.RIGHTJUSTIFY    	= 16384	! MF.RIGHTJUSTIFY

!====================================
! Menu Flags for Add/Check/EnableMenuItem
!====================================
SET	MFS.GRAYED          	= 3
SET	MFS.DISABLED        	= 3	! MFS.GRAYED
SET	MFS.CHECKED         	= 8	! MF.CHECKED
SET	MFS.HILITE          	= 128	! MF.HILITE
SET	MFS.ENABLED         	= 0	! MF.ENABLED
SET	MFS.UNCHECKED       	= 0	! MF.UNCHECKED
SET	MFS.UNHILITE        	= 0	! MF.UNHILITE
SET	MFS.DEFAULT         	= 4096	! MF.DEFAULT


!====================================
! Toolbar constants normally contained
! in COMMCTRL.H
!====================================
!Set IPN.FIRST						= 4294966436	! (0U-860U)       // internet address
!Set CBEN.FIRST					= 4294966496	! (0U-800U)       // combo box ex
!Set DTN.FIRST						= 4294966536	! (0U-760U)       // datetimepick
!Set MCN.FIRST						= 4294966546	! (0U-750U)       // monthcal
!Set TBN.FIRST						= 4294966596	! (0U-700U)       // toolbar
!Set UDN.FIRST						= 4294966575	! (0U-721)        // updown
!Set UNKNOWN3.FIRST				= 4294966696	! (0U-600U)       // unknown
!Set TCN.FIRST						= 4294966746	! (0U-550U)       // tab control
!Set UNKNOWN2.FIRST				= 4294966796	! (0U-500U)       // unknown
!Set TVN.FIRST						= 4294966896	! (0U-400U)       // treeview
!Set HDN.FIRST						= 4294966996	! (0U-300U)       // header
!Set UNKNOWN1.FIRST				= 4294967096	! (0U-200U)       // unknown
!Set LVN.FIRST						= 4294967196	! (0U-100U)       // listview
!Set NM.FIRST						= 4294967296	! (0U-0U)       	// Notify


SET	TBSTATE.CHECKED         = 1
SET	TBSTATE.PRESSED         = 2
SET	TBSTATE.ENABLED         = 4
SET	TBSTATE.HIDDEN          = 8
SET	TBSTATE.INDETERMINATE   = 16
SET	TBSTATE.WRAP            = 32
SET	TBSTATE.ELLIPSES        = 64


SET	TBSTYLE.BUTTON          = 0
SET	TBSTYLE.SEP             = 1
SET	TBSTYLE.CHECK           = 2
SET	TBSTYLE.GROUP           = 4
SET	TBSTYLE.CHECKGROUP      = 6	! (TBSTYLE.GROUP | TBSTYLE.CHECK)
SET	TBSTYLE.DROPDOWN        = 8

SET	TBSTYLE.TOOLTIPS        = 256
SET	TBSTYLE.WRAPABLE        = 512
SET	TBSTYLE.ALTDRAG         = 1024
SET	TBSTYLE.FLAT            = 2048
SET	TBSTYLE.LIST            = 4096
SET	TBSTYLE.CUSTOMERASE     = 8192


!====================================
! LoadImage constants
!====================================
SET	LR.DEFAULTCOLOR     		= 0
SET	LR.MONOCHROME       		= 1
SET	LR.COLOR            		= 2
SET	LR.COPYRETURNORG    		= 4
SET	LR.COPYDELETEORG    		= 8
SET	LR.LOADFROMFILE     		= 16
SET	LR.LOADTRANSPARENT  		= 32
SET	LR.DEFAULTSIZE      		= 64
SET	LR.VGACOLOR         		= 128
SET	LR.LOADMAP3DCOLORS  		= 4096
SET	LR.CREATEDIBSECTION 		= 8192
SET	LR.COPYFROMRESOURCE 		= 16384
SET	LR.SHARED           		= 32768

! Special ID means ID is a number
SET	LR.COMET.INTID      		= 65536

SET	IMAGE.BITMAP        		= 0
SET	IMAGE.ICON          		= 1
SET	IMAGE.CURSOR        		= 2


!====================================
! GetClassLong constants
!====================================
SET	GCL.MENUNAME        		= 4294967288	! (-8)
SET	GCL.HBRBACKGROUND   		= 4294967286	! (-10)
SET	GCL.HCURSOR         		= 4294967284	! (-12)
SET	GCL.HICON           		= 4294967282	! (-14)
SET	GCL.HMODULE         		= 4294967280	! (-16)
SET	GCL.CBWNDEXTRA      		= 4294967278	! (-18)
SET	GCL.CBCLSEXTRA      		= 4294967276	! (-20)
SET	GCL.WNDPROC         		= 4294967272	! (-24)
SET	GCL.STYLE           		= 4294967270	! (-26)
SET	GCL.ATOM            		= 4294967264	! (-32)
SET	GCL.HICONSM         		= 4294967262	! (-34)

.IFNDEF DRAW.TEXT.DEFINED
SET DRAW.TEXT.DEFINED = 1
!
! This code is duplicated in #cosptrd
! DrawText() Format Flags
SET	DT.TOP					= 0
SET	DT.LEFT					= 0
SET	DT.CENTER				= 1
SET	DT.RIGHT					= 2
SET	DT.VCENTER				= 4
SET	DT.BOTTOM				= 8
SET	DT.WORDBREAK			= 16
SET	DT.SINGLELINE			= 32
SET	DT.EXPANDTABS			= 64
SET	DT.TABSTOP				= 128
SET	DT.NOCLIP				= 256
SET	DT.EXTERNALLEADING	= 512
SET	DT.CALCRECT				= 1024
SET	DT.NOPREFIX				= 2048
SET	DT.INTERNAL				= 4096
SET	DT.EDITCONTROL			= 8192
SET	DT.PATH.ELLIPSIS		= 16384
SET	DT.END.ELLIPSIS		= 32768
SET	DT.MODIFYSTRING		= 65536
SET	DT.RTLREADING			= 131072
SET	DT.WORD.ELLIPSIS		= 262144
.ENDIF	! DRAW.TEXT.DEFINED

Set NM.OUTOFMEMORY		= 4294967295	! (NM_FIRST-1)
Set NM.CLICK				= 4294967294	! (NM_FIRST-2)    // uses NMCLICK struct
Set NM.DBLCLK				= 4294967293	! (NM_FIRST-3)
Set NM.RETURN				= 4294967292	! (NM_FIRST-4)
Set NM.RCLICK				= 4294967291	! (NM_FIRST-5)    // uses NMCLICK struct
Set NM.RDBLCLK				= 4294967290	! (NM_FIRST-6)
Set NM.SETFOCUS			= 4294967289	! (NM_FIRST-7)
Set NM.KILLFOCUS			= 4294967288	! (NM_FIRST-8)
Set NM.CUSTOMDRAW			= 4294967284	! (NM_FIRST-12)
Set NM.HOVER				= 4294967283	! (NM_FIRST-13)

.IFDEF CF.TABCTRL.CODE

! TabCtrl Styles
SET	TCS.SCROLLOPPOSITE		= 1   ! assumes multiline tab
SET	TCS.BOTTOM					= 2
SET	TCS.RIGHT					= 2
SET	TCS.MULTISELECT			= 4  ! allow multi-select in button mode
SET	TCS.FORCEICONLEFT			= 16
SET	TCS.FORCELABELLEFT		= 32
SET	TCS.HOTTRACK				= 64
SET	TCS.VERTICAL				= 128
SET	TCS.TABS						= 0
SET	TCS.BUTTONS					= 256
SET	TCS.SINGLELINE				= 0
SET	TCS.MULTILINE				= 512
SET	TCS.RIGHTJUSTIFY			= 0
SET	TCS.FIXEDWIDTH				= 1024
SET	TCS.RAGGEDRIGHT			= 2048
SET	TCS.FOCUSONBUTTONDOWN	= 4096
SET	TCS.OWNERDRAWFIXED		= 8192
SET	TCS.TOOLTIPS				= 16384
SET	TCS.FOCUSNEVER				= 32768

! TabCtrl messages
SET	TCM.FIRST					= 4864	! 0x1300

SET	TCM.GETIMAGELIST			= 4866	! (TCM_FIRST + 2)
SET	TCM.SETIMAGELIST			= 4867	! (TCM_FIRST + 3)
SET	TCM.GETITEMCOUNT			= 4868	! (TCM_FIRST + 4)
SET	TCM.GETITEM					= 4869	! (TCM_FIRST + 5)
SET	TCM.SETITEM					= 4870	! (TCM_FIRST + 6)
SET	TCM.INSERTITEM				= 4871	! (TCM_FIRST + 7)
SET	TCM.DELETEITEM				= 4872	! (TCM_FIRST + 8)
SET	TCM.DELETEALLITEMS		= 4873	! (TCM_FIRST + 9)
SET	TCM.GETITEMRECT			= 4874	! (TCM_FIRST + 10)
SET	TCM.GETCURSEL				= 4875	! (TCM_FIRST + 11)
SET	TCM.SETCURSEL				= 4876	! (TCM_FIRST + 12)
SET	TCM.HITTEST					= 4877	! (TCM_FIRST + 13)
SET	TCM.SETITEMEXTRA			= 4878	! (TCM_FIRST + 14)
SET	TCM.ADJUSTRECT				= 4904	! (TCM_FIRST + 40)
SET	TCM.SETITEMSIZE			= 4905	! (TCM_FIRST + 41)
SET	TCM.REMOVEIMAGE			= 4906	! (TCM_FIRST + 42)
SET	TCM.SETPADDING				= 4907	! (TCM_FIRST + 43)
SET	TCM.GETROWCOUNT			= 4908	! (TCM_FIRST + 44)
SET	TCM.GETTOOLTIPS			= 4909	! (TCM_FIRST + 45)
SET	TCM.SETTOOLTIPS			= 4910	! (TCM_FIRST + 46)
SET	TCM.GETCURFOCUS			= 4911	! (TCM_FIRST + 47)
SET	TCM.SETCURFOCUS			= 4912	! (TCM_FIRST + 48)
SET	TCM.SETMINTABWIDTH		= 4913	! (TCM_FIRST + 49)
SET	TCM.DESELECTALL			= 4914	! (TCM_FIRST + 50)

SET	TCHT.NOWHERE				= 1
SET	TCHT.ONITEMICON			= 2
SET	TCHT.ONITEMLABEL			= 4
SET	TCHT.ONITEM					= 6	! (TCHT_ONITEMICON | TCHT_ONITEMLABEL)

! TabCtrl Item State
SET	TCIF.TEXT					= 1
SET	TCIF.IMAGE					= 2
SET	TCIF.RTLREADING			= 4
SET	TCIF.PARAM					= 8
SET	TCIF.STATE					= 16

SET	TCIS.BUTTONPRESSED		= 1

! TabCtrl Notify Message
SET	TCN.KEYDOWN					= 4294966746 	! (TCN.FIRST - 0)
SET	TCN.SELCHANGE				= 4294966745  	! (TCN.FIRST - 1)
SET	TCN.SELCHANGING			= 4294966744   ! (TCN.FIRST - 2)
SET TCN.FOCUSCHANGE			= 4294966742   ! (TCN.FIRST - 4)
SET TCN.SETFOCUS			= 4294966740   ! (TCN.FIRST - 6)

.ENDIF

.IFDEF CF.TREEVIEW.CODE
SET	WC.TREEVIEW$				= "SysTreeView32"

! TreeView Styles
SET	TVS.HASBUTTONS				= 1
SET	TVS.HASLINES				= 2
SET	TVS.LINESATROOT			= 4
SET	TVS.EDITLABELS				= 8
SET	TVS.DISABLEDRAGDROP		= 16
SET	TVS.SHOWSELALWAYS			= 32
SET	TVS.RTLREADING				= 64
SET	TVS.NOTOOLTIPS				= 128
SET	TVS.CHECKBOXES				= 256
SET	TVS.TRACKSELECT			= 512
SET	TVS.SHAREDIMAGELISTS		= 0
SET	TVS.PRIVATEIMAGELISTS	= 1024

! TreeView Item State
SET	TVIF.TEXT					= 1
SET	TVIF.IMAGE					= 2
SET	TVIF.PARAM					= 4
SET	TVIF.STATE					= 8
SET	TVIF.HANDLE					= 16
SET	TVIF.SELECTEDIMAGE		= 32
SET	TVIF.CHILDREN				= 64
SET	TVIS.SELECTED				= 2
SET	TVIS.CUT						= 4
SET	TVIS.DROPHILITED			= 8
SET	TVIS.BOLD					= 16
SET	TVIS.EXPANDED				= 32
SET	TVIS.EXPANDEDONCE			= 64
SET	TVIS.EXPANDPARTIAL		= 128
SET	TVIS.OVERLAYMASK			= 3840		! 0x0F00
SET	TVIS.STATEIMAGEMASK		= 61440		! 0xF000
SET	TVIS.USERMASK				= 61440		! 0xF000

SET	TVI.ROOT$					= "@0000FFFF@"	! 0xFFFF0000
SET	TVI.FIRST$					= "@0100FFFF@"	! 0xFFFF0001
SET	TVI.LAST$					= "@0200FFFF@"	! 0xFFFF0002
SET	TVI.SORT$					= "@0300FFFF@"	! 0xFFFF0003

! TreeView messages
SET	TV.FIRST$					= "@0011@"	! 4352	! 0x1100

SET	TVM.INSERTITEM$			= "@0011@"	! 4352	! (TV.FIRST + 0)
SET	TVM.DELETEITEM$         = "@0111@"	! 4353	! (TV_FIRST + 1)
SET	TVM.EXPAND$					= "@0211@"	! 4354	! (TV_FIRST + 2)
SET	TVM.UNUSED1$				= "@0311@"	! 4355	! (TV_FIRST + 3)
SET	TVM.GETITEMRECT$			= "@0411@"	! 4356	! (TV_FIRST + 4)
SET	TVM.GETCOUNT$				= "@0511@"	! 4357	! (TV_FIRST + 5)
SET	TVM.GETINDENT$				= "@0611@"	! 4358	! (TV_FIRST + 6)
SET	TVM.SETINDENT$				= "@0711@"	! 4359	! (TV_FIRST + 7)
SET	TVM.GETIMAGELIST$			= "@0811@"	! 4360	! (TV_FIRST + 8)
SET	TVM.SETIMAGELIST$			= "@0911@"	! 4361	! (TV_FIRST + 9)
SET	TVM.GETNEXTITEM$			= "@0a11@"	! 4362	! (TV_FIRST + 10)
SET	TVM.SELECTITEM$			= "@0b11@"	! 4363	! (TV_FIRST + 11)
SET	TVM.GETITEM$				= "@0c11@"	! 4364	! (TV_FIRST + 12)
SET	TVM.SETITEM$				= "@0d11@"	! 4365	! (TV_FIRST + 13)
SET	TVM.EDITLABEL$				= "@0e11@"	! 4366	! (TV_FIRST + 14)
SET	TVM.GETEDITCONTROL$		= "@0f11@"	! 4367	! (TV_FIRST + 15)
SET	TVM.GETVISIBLECOUNT$		= "@1011@"	! 4368	! (TV_FIRST + 16)
SET	TVM.HITTEST$				= "@1111@"	! 4369	! (TV_FIRST + 17)
SET	TVM.CREATEDRAGIMAGE$		= "@1211@"	! 4370	! (TV_FIRST + 18)
SET	TVM.SORTCHILDREN$			= "@1311@"	! 4371	! (TV_FIRST + 19)
SET	TVM.ENSUREVISIBLE$		= "@1411@"	! 4372	! (TV_FIRST + 20)
SET	TVM.SORTCHILDRENCB$		= "@1511@"	! 4373	! (TV_FIRST + 21)
SET	TVM.ENDEDITLABELNOW$		= "@1611@"	! 4374	! (TV_FIRST + 22)
SET	TVM.GETISEARCHSTRING$	= "@1711@"	! 4375	! (TV_FIRST + 23)
SET	TVM.SETTOOLTIPS$			= "@1811@"	! 4376	! (TV_FIRST + 24)
SET	TVM.GETTOOLTIPS$			= "@1911@"	! 4377	! (TV_FIRST + 25)

SET	TVN.SELCHANGING			= 4294966895	! (TVN_FIRST-1)
SET	TVN.SELCHANGED				= 4294966894	! (TVN_FIRST-2)

SET	TVC.UNKNOWN					= 0
SET	TVC.BYMOUSE					= 1
SET	TVC.BYKEYBOARD				= 2

SET	TVN.GETDISPINFO			= 4294966893	! (TVN_FIRST-3)
SET	TVN.SETDISPINFO			= 4294966892	! (TVN_FIRST-4)

SET	TVIF.DI.SETITEM			= 4096

SET	TVN.ITEMEXPANDING			= 4294966891	! (TVN_FIRST-5)
SET	TVN.ITEMEXPANDED			= 4294966890	! (TVN_FIRST-6)
SET	TVN.BEGINDRAG				= 4294966889	! (TVN_FIRST-7)
SET	TVN.BEGINRDRAG				= 4294966888	! (TVN_FIRST-8)
SET	TVN.DELETEITEM				= 4294966887	! (TVN_FIRST-9)
SET	TVN.BEGINLABELEDIT		= 4294966886	! (TVN_FIRST-10)
SET	TVN.ENDLABELEDIT			= 4294966885	! (TVN_FIRST-11)
SET	TVN.KEYDOWN					= 4294966884	! (TVN_FIRST-12)

SET	TVE.COLLAPSE				= 1
SET	TVE.EXPAND					= 2
SET	TVE.TOGGLE					= 3
SET	TVE.EXPANDPARTIAL			= 16384	! 0x4000
SET	TVE.COLLAPSERESET			= 32768	! 0x8000

SET	TVSIL.NORMAL				= 0
SET	TVSIL.STATE					= 2

SET	TVGN.ROOT$					= "@00@"
SET	TVGN.NEXT$					= "@01@"
SET	TVGN.PREVIOUS$				= "@02@"
SET	TVGN.PARENT$				= "@03@"
SET	TVGN.CHILD$					= "@04@"
SET	TVGN.FIRSTVISIBLE$		= "@05@"
SET	TVGN.NEXTVISIBLE$			= "@06@"
SET	TVGN.PREVIOUSVISIBLE$	= "@07@"
SET	TVGN.DROPHILITE$			= "@08@"
SET	TVGN.CARET$					= "@09@"

SET	TVHT.NOWHERE				= 1
SET	TVHT.ONITEMICON			= 2
SET	TVHT.ONITEMLABEL			= 4
SET	TVHT.ONITEM					= 70	! (TVHT.ONITEMICON | TVHT.ONITEMLABEL | TVHT.ONITEMSTATEICON)
SET	TVHT.ONITEMINDENT			= 8
SET	TVHT.ONITEMBUTTON			= 16
SET	TVHT.ONITEMRIGHT			= 32
SET	TVHT.ONITEMSTATEICON		= 64

SET	TVHT.ABOVE					= 256
SET	TVHT.BELOW					= 512
SET	TVHT.TORIGHT				= 1024
SET	TVHT.TOLEFT					= 2048

.ENDIF	! CF.TREEVIEW.CODE

.IFDEF CF.LISTVIEW.CODE
Set LVCF.FMT					= 1	! 0x0001
Set LVCF.WIDTH					= 2	! 0x0002
Set LVCF.TEXT					= 4	! 0x0004
Set LVCF.SUBITEM				= 8	! 0x0008
Set LVCF.IMAGE					= 16	! 0x0010
Set LVCF.ORDER					= 32	! 0x0020

Set LVCFMT.LEFT					= 0	! 0x0000
Set LVCFMT.RIGHT				= 1	! 0x0001
Set LVCFMT.CENTER				= 2	! 0x0002
Set LVCFMT.JUSTIFYMASK			= 3	! 0x0003
Set LVCFMT.IMAGE				= 2048	! 0x0800
Set LVCFMT.BITMAP.ON.RIGHT		= 4096	! 0x1000
Set LVCFMT.COL.HAS.IMAGES		= 32768	! 0x8000

Set LVN.ITEMCHANGING			= 4294967196	!	(LVN_FIRST-0)
Set LVN.ITEMCHANGED				= 4294967195	!	(LVN_FIRST-1)
Set LVN.INSERTITEM				= 4294967194	!	(LVN_FIRST-2)
Set LVN.DELETEITEM				= 4294967193	!	(LVN_FIRST-3)
Set LVN.DELETEALLITEMS			= 4294967192	!	(LVN_FIRST-4)
Set LVN.BEGINLABELEDIT			= 4294967191	!	(LVN_FIRST-5)
Set LVN.ENDLABELEDIT			= 4294967190	!	(LVN_FIRST-6)
Set LVN.COLUMNCLICK				= 4294967188	!	(LVN_FIRST-8)
Set LVN.BEGINDRAG				= 4294967187	!	(LVN_FIRST-9)

Set LVN.BEGINRDRAG				= 4294967185	!	(LVN_FIRST-11)

Set LVN.ODCACHEHINT				= 4294967183	!	(LVN_FIRST-13)
Set LVN.ITEMACTIVATE			= 4294967182	!	(LVN_FIRST-14)
Set LVN.ODSTATECHANGED			= 4294967181	!	(LVN_FIRST-15)

Set LVN.HOTTRACK					= 4294967175	!	(LVN_FIRST-21)

Set LVN.GETDISPINFO				= 4294967146	!	(LVN_FIRST-50)
Set LVN.SETDISPINFO				= 4294967145	!	(LVN_FIRST-51)
Set LVN.ODFINDITEM				= 4294967144	!	(LVN_FIRST-52)

Set LVS.ICON				= 0	! 0x0000
Set LVS.REPORT				= 1	! 0x0001
Set LVS.SMALLICON			= 2	! 0x0002
Set LVS.LIST				= 3	! 0x0003
Set LVS.TYPEMASK			= 3	! 0x0003
Set LVS.SINGLESEL			= 4	! 0x0004
Set LVS.SHOWSELALWAYS	= 8	! 0x0008
Set LVS.SORTASCENDING	= 16	! 0x0010
Set LVS.SORTDESCENDING	= 32	! 0x0020
Set LVS.SHAREIMAGELISTS	= 64	! 0x0040
Set LVS.NOLABELWRAP		= 128	! 0x0080
Set LVS.AUTOARRANGE		= 256	! 0x0100
Set LVS.EDITLABELS		= 512	! 0x0200
Set LVS.OWNERDATA			= 4096	! 0x1000
Set LVS.NOSCROLL			= 8192	! 0x2000
Set LVS.TYPESTYLEMASK	= 64512	! 0xfc00
Set LVS.ALIGNTOP			= 0		! 0x0000
Set LVS.ALIGNLEFT			= 2048	! 0x0800
Set LVS.ALIGNMASK			= 3072	! 0x0c00
Set LVS.OWNERDRAWFIXED	= 1024	! 0x0400
Set LVS.NOCOLUMNHEADER	= 16384	! 0x4000
Set LVS.NOSORTHEADER		= 32768	! 0x8000

Set LVS.EX.GRIDLINES        = 1 ! 0x00000001
Set LVS.EX.SUBITEMIMAGES    = 2 ! 0x00000002
Set LVS.EX.CHECKBOXES       = 4 ! 0x00000004
Set LVS.EX.TRACKSELECT      = 8 ! 0x00000008
Set LVS.EX.HEADERDRAGDROP   = 16 ! 0x00000010
Set LVS.EX.FULLROWSELECT    = 32 ! 0x00000020 // applies to report mode only
Set LVS.EX.ONECLICKACTIVATE = 64 ! 0x00000040
Set LVS.EX.TWOCLICKACTIVATE = 128 ! 0x00000080
Set LVS.EX.FLATSB           = 256 ! 0x00000100
Set LVS.EX.REGIONAL         = 512 ! 0x00000200
Set LVS.EX.INFOTIP          = 1024 ! 0x00000400 // listview does InfoTips for you
Set LVS.EX.UNDERLINEHOT     = 2048 ! 0x00000800
Set LVS.EX.UNDERLINECOLD    = 4096 ! 0x00001000
Set LVS.EX.MULTIWORKAREAS   = 8192 ! 0x00002000

Set LVIF.TEXT				= 1	! 0x0001 - The pszText member is valid or must be filled in.
Set LVIF.IMAGE				= 2	! 0x0002 - The iImage member is valid or must be filled in.
Set LVIF.PARAM				= 4	! 0x0004 - The lParam member is valid or must be filled in.
Set LVIF.STATE				= 8	! 0x0008 - The state member is valid or must be filled in.
Set LVIF.INDENT			= 16	! 0x0010 - The iIndent member is valid or must be filled in.
Set LVIF.NORECOMPUTE		= 2048	! 0x0800 - The control will not generate LVN_GETDISPINFO to retrieve text information if it receives an LVM_GETITEM message. Instead, the pszText member will contain LPSTR_TEXTCALLBACK.
Set LVIF.DI.SETITEM		= 4096	! 0x1000 - The operating system should store the requested list item information and not ask for it again. This flag is used only with the LVN_GETDISPINFO notification message.
Set cosLVIF.PARSETABS	= 8192	! 0x2000 - Special Comet flag to decode inserted ietm string with tabs
!Set cosLVIF.PARAM			= 16384	! 0x4000 - Special Comet flag to add data to item

Set LVM.FIRST				= 4096	! 0x1000
Set LVM.GETBKCOLOR		= 4096 	! (LVM_FIRST + 0)
Set LVM.SETBKCOLOR		= 4097	! (LVM_FIRST + 1)
Set LVM.GETIMAGELIST		= 4098	! (LVM_FIRST + 2)
Set LVM.SETIMAGELIST		= 4099	! (LVM_FIRST + 3)
Set LVM.GETITEMCOUNT		= 4100	! (LVM_FIRST + 4)
Set LVM.GETITEM			= 4101	! (LVM_FIRST + 5)
Set LVM.SETITEM			= 4102	! (LVM_FIRST + 6)
Set LVM.INSERTITEM		= 4103	! (LVM_FIRST + 7)
Set LVM.DELETEITEM		= 4104	! (LVM_FIRST + 8)
Set LVM.DELETEALLITEMS	= 4105	! (LVM_FIRST + 9)
Set LVM.GETCALLBACKMASK	= 4106	! (LVM_FIRST + 10)
Set LVM.SETCALLBACKMASK	= 4107	! (LVM_FIRST + 11)
Set LVM.GETNEXTITEM		= 4108	! (LVM_FIRST + 12)
Set LVM.FINDITEM	          = 4109 ! (LVM_FIRST + 13)
Set LVM.GETITEMRECT         = 4110 ! (LVM_FIRST + 14)
Set LVM.SETITEMPOSITION     = 4111 ! (LVM_FIRST + 15)
Set LVM.GETITEMPOSITION     = 4112 ! (LVM_FIRST + 16)
Set LVM.GETSTRINGWIDTH	    = 4113 ! (LVM_FIRST + 17)
Set LVM.HITTEST             = 4114 ! (LVM_FIRST + 18)
Set LVM.ENSUREVISIBLE       = 4115 ! (LVM_FIRST + 19)
Set LVM.SCROLL              = 4116 ! (LVM_FIRST + 20)
Set LVM.REDRAWITEMS         = 4117 ! (LVM_FIRST + 21)
Set LVM.ARRANGE             = 4118 ! (LVM_FIRST + 22)
Set LVM.EDITLABEL           = 4119 ! (LVM_FIRST + 23)
Set LVM.GETEDITCONTROL      = 4120 ! (LVM_FIRST + 24)
Set LVM.GETCOLUMN           = 4121 ! (LVM_FIRST + 25)
Set LVM.SETCOLUMN           = 4122 ! (LVM_FIRST + 26)
Set LVM.INSERTCOLUMN        = 4123 ! (LVM_FIRST + 27)
Set LVM.DELETECOLUMN        = 4124 ! (LVM_FIRST + 28)
Set LVM.GETCOLUMNWIDTH      = 4125 ! (LVM_FIRST + 29)
Set LVM.SETCOLUMNWIDTH      = 4126 ! (LVM_FIRST + 30)
Set LVM.GETHEADER           = 4127 ! (LVM_FIRST + 31)

Set LVM.CREATEDRAGIMAGE     = 4129 ! (LVM_FIRST + 33)
Set LVM.GETVIEWRECT         = 4130 ! (LVM_FIRST + 34)
Set LVM.GETTEXTCOLOR        = 4131 ! (LVM_FIRST + 35)
Set LVM.SETTEXTCOLOR        = 4132 ! (LVM_FIRST + 36)
Set LVM.GETTEXTBKCOLOR      = 4133 ! (LVM_FIRST + 37)
Set LVM.SETTEXTBKCOLOR      = 4134 ! (LVM_FIRST + 38)
Set LVM.GETTOPINDEX         = 4135 ! (LVM_FIRST + 39)
Set LVM.GETCOUNTPERPAGE     = 4136 ! (LVM_FIRST + 40)
Set LVM.GETORIGIN           = 4137 ! (LVM_FIRST + 41)
Set LVM.UPDATE              = 4138 ! (LVM_FIRST + 42)
Set LVM.SETITEMSTATE        = 4139 ! (LVM_FIRST + 43)
Set LVM.GETITEMSTATE        = 4140 ! (LVM_FIRST + 44)
Set LVM.GETITEMTEXT         = 4141 ! (LVM_FIRST + 45)
Set LVM.SETITEMTEXT         = 4142 ! (LVM_FIRST + 46)
Set LVM.SETITEMCOUNT        = 4143 ! (LVM_FIRST + 47)
Set LVM.SORTITEMS           = 4144 ! (LVM_FIRST + 48)
Set LVM.SETITEMPOSITION32   = 4145 ! (LVM_FIRST + 49)
Set LVM.GETSELECTEDCOUNT    = 4146 ! (LVM_FIRST + 50)
Set LVM.GETITEMSPACING      = 4147 ! (LVM_FIRST + 51)
Set LVM.GETISEARCHSTRING    = 4148 ! (LVM_FIRST + 52)
Set LVM.SETICONSPACING      = 4149 ! (LVM_FIRST + 53)
Set LVM.SETEXTENDEDLISTVIEWSTYLE = 4150 ! (LVM_FIRST 54)
Set LVM.GETEXTENDEDLISTVIEWSTYLE = 4151 ! (LVM_FIRST 55)
Set LVM.GETSUBITEMRECT      = 4152 ! (LVM_FIRST + 56)
Set LVM.SUBITEMHITTEST      = 4153 ! (LVM_FIRST + 57)
Set LVM.SETCOLUMNORDERARRAY = 4154 ! (LVM_FIRST + 58)
Set LVM.GETCOLUMNORDERARRAY = 4155 ! (LVM_FIRST + 59)
Set LVM.SETHOTITEM          = 4156 ! (LVM_FIRST + 60)
Set LVM.GETHOTITEM          = 4157 ! (LVM_FIRST + 61)
Set LVM.SETHOTCURSOR        = 4158 ! (LVM_FIRST + 62)
Set LVM.GETHOTCURSOR        = 4159 ! (LVM_FIRST + 63)
Set LVM.APPROXIMATEVIEWRECT = 4160 ! (LVM_FIRST + 64)
Set LVM.SETWORKAREAS        = 4161 ! (LVM_FIRST + 65)
Set LVM.GETSELECTIONMARK    = 4162 ! (LVM_FIRST + 66)
Set LVM.SETSELECTIONMARK    = 4163 ! (LVM_FIRST + 67)
Set LVM.SETBKIMAGE          = 4164 ! (LVM_FIRST + 68)
Set LVM.GETBKIMAGE          = 4165 ! (LVM_FIRST + 69)
Set LVM.GETWORKAREAS        = 4166 ! (LVM_FIRST + 70)
Set LVM.SETHOVERTIME        = 4167 ! (LVM_FIRST + 71)
Set LVM.GETHOVERTIME        = 4168 ! (LVM_FIRST + 72)
Set LVM.GETNUMBEROFWORKAREAS= 4169 ! (LVM_FIRST + 73)
Set LVM.SETTOOLTIPS         = 4170 ! (LVM_FIRST + 74)

Set LVM.GETTOOLTIPS         = 4174 ! (LVM_FIRST + 78)



Set LVNI.ALL				= 0
Set LVNI.FOCUSED			= 1
Set LVNI.SELECTED			= 2
Set LVNI.CUT				= 4
Set LVNI.DROPHILITED		= 8
Set LVNI.ABOVE				= 256
Set LVNI.BELOW				= 512
Set LVNI.TOLEFT			= 1024
Set LVNI.TORIGHT			= 2048

Set LVIS.FOCUSED        = 1
Set LVIS.SELECTED       = 2
Set LVIS.CUT            = 4
Set LVIS.DROPHILITED    = 8
Set LVIS.ACTIVATING     = 32

Set LVIS.OVERLAYMASK    = 3840	! 0x0F00
Set LVIS.STATEIMAGEMASK = 61440	! 0xF000

.ENDIF	! CF.LISTVIEW.CODE


! GetSystemMetrics() codes
SET	SM.CXSCREEN             = 0
SET	SM.CYSCREEN             = 1
SET	SM.CXVSCROLL            = 2
SET	SM.CYHSCROLL            = 3
SET	SM.CYCAPTION            = 4
SET	SM.CXBORDER             = 5
SET	SM.CYBORDER             = 6
SET	SM.CXDLGFRAME           = 7
SET	SM.CYDLGFRAME           = 8
SET	SM.CYVTHUMB             = 9
SET	SM.CXHTHUMB             = 10
SET	SM.CXICON               = 11
SET	SM.CYICON               = 12
SET	SM.CXCURSOR             = 13
SET	SM.CYCURSOR             = 14
SET	SM.CYMENU               = 15
SET	SM.CXFULLSCREEN         = 16
SET	SM.CYFULLSCREEN         = 17
SET	SM.CYKANJIWINDOW        = 18
SET	SM.MOUSEPRESENT         = 19
SET	SM.CYVSCROLL            = 20
SET	SM.CXHSCROLL            = 21
SET	SM.DEBUG                = 22
SET	SM.SWAPBUTTON           = 23
SET	SM.RESERVED1            = 24
SET	SM.RESERVED2            = 25
SET	SM.RESERVED3            = 26
SET	SM.RESERVED4            = 27
SET	SM.CXMIN                = 28
SET	SM.CYMIN                = 29
SET	SM.CXSIZE               = 30
SET	SM.CYSIZE               = 31
SET	SM.CXFRAME              = 32
SET	SM.CYFRAME              = 33
SET	SM.CXMINTRACK           = 34
SET	SM.CYMINTRACK           = 35
SET	SM.CXDOUBLECLK          = 36
SET	SM.CYDOUBLECLK          = 37
SET	SM.CXICONSPACING        = 38
SET	SM.CYICONSPACING        = 39
SET	SM.MENUDROPALIGNMENT    = 40
SET	SM.PENWINDOWS           = 41
SET	SM.DBCSENABLED          = 42
SET	SM.CMOUSEBUTTONS        = 43


! Color Types
SET	CTLCOLOR.MSGBOX				= 0
SET	CTLCOLOR.EDIT					= 1
SET	CTLCOLOR.LISTBOX				= 2
SET	CTLCOLOR.BTN					= 3
SET	CTLCOLOR.DLG					= 4
SET	CTLCOLOR.SCROLLBAR			= 5
SET	CTLCOLOR.STATIC				= 6
SET	CTLCOLOR.MAX					= 7

SET	COLOR.SCROLLBAR			= 0
SET	COLOR.BACKGROUND			= 1
SET	COLOR.ACTIVECAPTION		= 2
SET	COLOR.INACTIVECAPTION	= 3
SET	COLOR.MENU					= 4
SET	COLOR.WINDOW				= 5
SET	COLOR.WINDOWFRAME			= 6
SET	COLOR.MENUTEXT				= 7
SET	COLOR.WINDOWTEXT			= 8
SET	COLOR.CAPTIONTEXT			= 9
SET	COLOR.ACTIVEBORDER		= 10
SET	COLOR.INACTIVEBORDER		= 11
SET	COLOR.APPWORKSPACE		= 12
SET	COLOR.HIGHLIGHT			= 13
SET	COLOR.HIGHLIGHTTEXT		= 14
SET	COLOR.BTNFACE				= 15
SET	COLOR.BTNSHADOW			= 16
SET	COLOR.GRAYTEXT				= 17
SET	COLOR.BTNTEXT				= 18
SET	COLOR.INACTIVECAPTIONTEXT	= 19
SET	COLOR.BTNHIGHLIGHT		= 20

!SET	COLOR.3DDKSHADOW			= 21
!SET	COLOR.3DLIGHT				= 22
!SET	COLOR.INFOTEXT				= 23
!SET	COLOR.INFOBK				= 24

!SET	COLOR.HOTLIGHT				= 26
!SET	COLOR.GRADIENTACTIVECAPTION	= 27
!SET	COLOR.GRADIENTINACTIVECAPTION	= 28

! Choose Color dialog flags
Set CC.RGBINIT				= 1
Set CC.FULLOPEN				= 2
Set CC.PREVENTFULLOPEN		= 4
Set CC.SOLIDCOLOR			= 128
Set CC.ANYCOLOR				= 256

! Choose File dialog flags
Set OFN.OVERWRITEPROMPT	= 2				! Causes the Save As dialog box to generate a message box if the selected file already exists
Set OFN.PATHMUSTEXIST	= 2048			! The user can type only valid paths and file names
Set OFN.FILEMUSTEXIST	= 4096			! The user can type only names of existing files in the File Name entry field
Set OFN.CREATEPROMPT	= 8192			! Ask the user for permission to create a non-existant file.
Set OFN.NONETWORKBUTTON	= 131072		! Hides and disables the Network button
Set OFN.DONTADDTORECENT	= 33554432		! Prevents the system from adding the selected file to the user's most recently used documents
Set OFN.FORCESHOWHIDDEN	= 268435456		! Show All files including System and hidden files
Set OFN.COS.SAVEAS		= 2147483648    ! Display as "Save As" dialog

! Choose Folder dialog flags
Set BIF.RETURNONLYFSDIRS   = 1		! For finding a folder to start document searching
Set BIF.DONTGOBELOWDOMAIN  = 2		! For starting the Find Computer
Set BIF.RETURNFSANCESTORS  = 8		! Only return file system ancestors
Set BIF.EDITBOX            = 16		! Add an editbox to the dialog
Set BIF.VALIDATE           = 32		! insist on valid result (or CANCEL)
Set BIF.NEWDIALOGSTYLE     = 64		! Use the new dialog layout with the ability to resize
Set BIF.USENEWUI           = 80		! (BIF.NEWDIALOGSTYLE | BIF.EDITBOX)
Set BIF.BROWSEINCLUDEURLS  = 128	! Allow URLs to be displayed or entered. (Requires BIF.USENEWUI)
Set BIF.UAHINT             = 256	! Add a UA hint to the dialog, in place of the edit box. May not be combined with BIF_EDITBOX
Set BIF.NONEWFOLDERBUTTON  = 512	! Do not add the "New Folder" button to the dialog.  Only applicable with BIF.NEWDIALOGSTYLE.
Set BIF.NOTRANSLATETARGETS = 1024	! don't traverse target as shortcut
Set BIF.BROWSEFORCOMPUTER  = 4096	! Browsing for Computers.
Set BIF.BROWSEFORPRINTER   = 8192	! Browsing for Printers
Set BIF.BROWSEINCLUDEFILES = 16384	! Browsing for Everything
Set BIF.SHAREABLE          = 32768	! sharable resources displayed (remote shares, requires BIF.USENEWUI)


.IFDEF CF.DATETIME.CODE
Set DTM.GETSYSTEMTIME	= 4097
Set DTM.SETSYSTEMTIME	= 4098
Set DTM.GETRANGE		= 4099
Set DTM.SETRANGE		= 4100
Set DTM.SETFORMAT		= 4101
Set DTM.SETMCCOLOR		= 4102
Set DTM.GETMCCOLOR		= 4103
Set DTM.GETMONTHCAL		= 4104
Set DTM.SETMCFONT		= 4105
Set DTM.GETMCFONT		= 4106

Set DTS.UPDOWN			= 1  ! use UPDOWN instead of MONTHCAL
Set DTS.SHOWNONE		= 2  ! allow a NONE selection
Set DTS.SHORTDATEFORMAT	= 0  ! use the short date format (app must forward WM_WININICHANGE messages)
Set DTS.LONGDATEFORMAT	= 4  ! use the long date format (app must forward WM_WININICHANGE messages)
Set DTS.TIMEFORMAT		= 9  ! use the time format (app must forward WM_WININICHANGE messages)
Set DTS.RIGHTALIGN		= 32 ! right-align popup instead of left-align it

Set GDT.ERROR			= 65535		! INTEL(-1)
Set GDT.VALID			= 0
Set GDT.NONE			= 1

Set DTN.DATETIMECHANGE = 4294966537 ! the systemtime has changed

.ENDIF	! CF.DATETIME.CODE

.ENDIF	! WINDOWS.DEFINED
