.IF DECPASS
.IFNDEF CopyFile.GetErrString
Set CopyFile.GetErrString = TRUE
.ENDIF

.IF CopyFile.GetErrString
Length 80 & Local CopyFile.ErrorString$
.ENDIF

Length 5.0 & Local CopyFile.Flags
Set CPYF.SOURCEREMOTE		= 1		! Source file is at remote
Set CPYF.REMOTEREQ			= 2		! If NOT CometAnywhere then fail if not remote session
Set CPYF.XFERASYNC			= 4		! Return upon start of transfer (not yet supported)
Set CPYF.MODIFY				= 64		! Check modify date - if zero then update always required
Set CPYF.CREATEALIAS			= 128		! Create CAFILES alias if required
Set CPYF.CHECKONLY			= 256		! Don't send file - just indicate if update needed
Set CPYF.DESTREMOTE			= 512		! Destination file is at remote
Set CPYF.SHOWPROG				= 1024	! Show progress bar
Set CPYF.OVERWRITE			= 2048	! Overwrite existing file
Set CPYF.MAKEDIR				= 4096	! Create directory

Length 5.0 & Local CopyFile.FuncError
Set CPYF.ERR.NOTSUPPORTED	= 0		! Function not supported
Set CPYF.ERR.UPDATEOK		= 1		! Success - update performed
Set CPYF.ERR.REMOTEREQ		= 2		! CometAnywhere required
Set CPYF.ERR.SOURCEERROR	= 3		! Source file error (see SubErrors)
Set CPYF.ERR.USERABORT		= 4		! Aborted by user
Set CPYF.ERR.INPROGRESS		= 5		! Function in progress (VF_XFERASYNC)
Set CPYF.ERR.NOUPDATEREQ	= 20		! Success - update not required
Set CPYF.ERR.UPDATEREQ		= 21		! Success - update required (VF_CHECKONLY)
Set CPYF.ERR.DESTERROR		= 22		! Destination file error (see SubErrors)

Length 5.0 & Local CopyFile.FileError
! Common Windows File Errors
Set ERROR.SUCCESS					= 0
Set ERROR.FILE.NOT.FOUND		= 2
Set ERROR.PATH.NOT.FOUND		= 3
Set ERROR.ACCESS.DENIED			= 5
Set ERROR.INVALID.ACCESS		= 12
Set ERROR.INVALID.DRIVE			= 15
Set ERROR.CURRENT.DIRECTORY	= 16
Set ERROR.NO.MORE.FILES			= 18
Set ERROR.SHARING.VIOLATION	= 32
Set ERROR.LOCK.VIOLATION		= 33
Set ERROR.FILE.EXISTS			= 80
Set ERROR.BAD.PATHNAME			= 161

! Vars for 32 bit	CopyFile.GetResult
Length 4	& Local CopyFile.Result$
Length 10.0	& Local CopyFile.Result
Length 5.0 & Local CopyFile.LoResult, CopyFile.HiResult
Length 1.0 & Local CopyFile.Err
Length 2 & Local CopyFile.AX$, CopyFile.DX$
CopyFile.ResultFmt: Format CopyFile.AX$;CopyFile.DX$

.ELSE	! DECPASS
CopyFile.GetResult:
   Input (0, CopyFile.ResultFmt)
	CopyFile.AX$ = Sub(CopyFile.AX$, 2, 1) + Sub(CopyFile.AX$, 1, 1)
	CopyFile.DX$ = Sub(CopyFile.DX$, 2, 1) + Sub(CopyFile.DX$, 1, 1)
   CopyFile.FuncError = HexDec(CopyFile.AX$)
!	print "CopyFile.FuncError:";CopyFile.FuncError
   If (CopyFile.FuncError > 32767) Then _
   	CopyFile.FuncError = CopyFile.FuncError-65536	! Convert to 2's compliment signed integer
   CopyFile.FileError = HexDec(CopyFile.DX$)
!	print "CopyFile.FileError:";CopyFile.FileError
   If (CopyFile.FileError > 32767) Then _
   	CopyFile.FileError = CopyFile.FileError-65536	! Convert to 2's compliment signed integer

	Select Case CopyFile.FuncError
		Case CPYF.ERR.UPDATEOK;CPYF.ERR.NOUPDATEREQ;CPYF.ERR.UPDATEREQ
			CopyFile.Err = FALSE
		Case Else
			CopyFile.Err = TRUE
	EndSelect
Return

.IF CopyFile.GetErrString
CopyFile.GetErrorString:
	CopyFile.Err = TRUE

	Select Case CopyFile.FuncError
		Case CPYF.ERR.NOTSUPPORTED
			CopyFile.ErrorString$ = "Function not supported"
		Case CPYF.ERR.UPDATEOK
			CopyFile.ErrorString$ = "Success - update performed"
			CopyFile.Err = FALSE
		Case CPYF.ERR.NOUPDATEREQ
			CopyFile.ErrorString$ = "Success - update not required"
			CopyFile.Err = FALSE
		Case CPYF.ERR.UPDATEREQ
			CopyFile.ErrorString$ = "Success - update required (VF@_CHECKONLY)"
			CopyFile.Err = FALSE
		Case CPYF.ERR.REMOTEREQ
			CopyFile.ErrorString$ = "CometAnywhere required"
		Case CPYF.ERR.SOURCEERROR
			CopyFile.ErrorString$ = "Source"
			Gosub CopyFile.GetFileError
		Case CPYF.ERR.DESTERROR
			CopyFile.ErrorString$ = "Destination"
			Gosub CopyFile.GetFileError
		Case CPYF.ERR.USERABORT
			CopyFile.ErrorString$ = "Aborted by user"
		Case CPYF.ERR.INPROGRESS
			CopyFile.ErrorString$ = "Function in progress (VF@_XFERASYNC)"
		Case Else
			CopyFile.ErrorString$ = "Unknown function error ("+Strip(Str(CopyFile.FuncError))+")"
	EndSelect
Return

CopyFile.GetFileError:
	CopyFile.ErrorString$ = CopyFile.ErrorString$ + " file error ("+Strip(Str(CopyFile.FileError))+"): "

	Select Case CopyFile.FileError
		Case ERROR.SUCCESS
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Success"
		Case ERROR.FILE.NOT.FOUND
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "File Not Found"
		Case ERROR.PATH.NOT.FOUND
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Path Not Found"
		Case ERROR.ACCESS.DENIED
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Access Denied"
		Case ERROR.INVALID.ACCESS
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Invalid Access"
		Case ERROR.INVALID.DRIVE
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Invalid Drive"
		Case ERROR.CURRENT.DIRECTORY
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Current Directory"
		Case ERROR.NO.MORE.FILES
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "No more matching files"
		Case ERROR.SHARING.VIOLATION
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Sharing Violation"
		Case ERROR.LOCK.VIOLATION
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Lock Violation"
		Case ERROR.FILE.EXISTS
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "File Exists"
		Case ERROR.BAD.PATHNAME
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Bad Path Name"
		Case Else
			CopyFile.ErrorString$ = CopyFile.ErrorString$ + "Unknown Error"
	EndSelect
Return
.ENDIF	! CopyFile.GetErrString
.ENDIF	! EXEPASS
